/*
 * Хꥺɽե
 *	ɽ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_birth.c,v 1.3 2002/11/15 09:59:22 tonton Exp $
 */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbrb_name;			// ̾
static GtkAdjustment	*Wbrb_year;		// ǯ
static GtkAdjustment	*Wbrb_month;	// 
static GtkAdjustment	*Wbrb_day;		// 
static GtkWidget	*Wbrb_list;			// ꥹ
static gboolean		Wbrb_rmflag;		// ե饰
static gint			Wbrb_calendar;		// ܥֹ
static gboolean		Wbrb_chg_flag;		// ѹե饰

static void			wbrb_cb_destroy(void);
static void			wbrb_cb_mfile_expimp_clicked(GtkWidget *,
											gpointer, guint);
static void			wbrb_cb_list_selected(GtkWidget *,
						gint, gint, GdkEventButton *, gpointer);
static void			wbrb_cb_list_unselected(GtkWidget *,
						gint, gint, GdkEventButton *, gpointer);
static void			wbrb_cb_add_clicked(GtkWidget *, gpointer, guint);
static void			wbrb_cb_delete_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_calendar_clicked(GtkWidget *, gpointer);
static void			wbrb_cb_allsel_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_allcan_clicked(GtkWidget *,
										gpointer, guint);
static void			wbrb_cb_group_clicked(GtkWidget *, gpointer);
static gint			wbrb_cb_delete_event(GtkWidget *,
										GdkEvent *, gpointer);
static void			wbrb_cb_ok_clicked(GtkWidget *, gpointer, guint);
static void			wbrb_cb_cancel_clicked(GtkWidget *,
										gpointer, guint);
static GtkWidget	*wbrb_create_birth_window(GtkWidget *);
static void			wbrb_set_birthday_data(gchar *, gint);
static GtkWidget	*wbrb_create_birth_menu(GtkWidget *);
static void			wbrb_set_list_data(GtkWidget *);

/*===============
 *   ̾ : wbr_cb_mview_spcbirth_clicked()
 *     ǽ : ϥɥκ
 *    : ʤ
 */
void				wbr_cb_mview_spcbirth_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				main_window			// (I) ᥤ󥦥ɥ
)
{
	GtkWidget		*birth_window;		// ϥɥ

	Wbrb_rmflag = FALSE;
	Wbrb_chg_flag = FALSE;
	Wbrb_calendar = (gint)wbr_get_param(WBR_PRM_ID_CALENDAR);
	birth_window =
		wbrb_create_birth_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(birth_window);
	gtk_main();
}

/*===============
 *   ̾ : wbrb_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			wbrb_cb_destroy(void)
{
	wbr_free_datfile();
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrb_cb_mfile_expimp_clicked()
 *     ǽ : ݡȡݡȥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_mfile_expimp_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			birth_window,		// (I) ϥɥ
guint				ei_type				// (I) ݡȡݡ
)
{
	gint			loop_cnt;			// 롼ץ
	gchar			**list_item;		// ꥹȹ
	gint			old_man_cnt;		// ݡͿ
	gint			new_man_cnt;		// ݡȸͿ
	gchar			date_fmt[20];		// եեޥå
	gchar			temp_date[20];		// ʸ
	gchar			*user_name;			// ̾
	gint			birthday;			// 
	gboolean		item_select;		// 

	old_man_cnt = wbr_get_datfile_cnt();
	wbr_expimp_main(birth_window, ei_type);

	if (ei_type == WBR_EITYPE_IMPORT) {
		new_man_cnt = wbr_get_datfile_cnt();
		if (old_man_cnt != new_man_cnt) {
			list_item = g_malloc(2 * sizeof(gchar *));

			if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
				strcpy(date_fmt, "%Y/%m/%d");
			}
			else {
				strcpy(date_fmt, "%m/%d");
			}

			for (loop_cnt = old_man_cnt;
				loop_cnt < new_man_cnt; loop_cnt++) {
				user_name =
					wbr_get_datfile_item(WBR_MAN_NAME, loop_cnt);
				birthday = (gint)
					wbr_get_datfile_item(WBR_MAN_BIRTHDAY, loop_cnt);
				item_select = (gboolean)
					wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);

				wmc_get_date_string(temp_date, date_fmt, birthday);
				list_item[0] = g_strconcat(user_name, NULL);
				list_item[1] = g_strconcat(temp_date, NULL);
				gtk_clist_append(GTK_CLIST(Wbrb_list), list_item);
				g_free(list_item[0]);
				g_free(list_item[1]);

				gtk_clist_select_row(GTK_CLIST(Wbrb_list), loop_cnt, 1);
			}
			g_free(list_item);
			Wbrb_chg_flag = TRUE;
		}
	}
}

/*===============
 *   ̾ : wbrb_cb_list_selected()
 *     ǽ : ꥹ򥳡Хå
 *    : ʤ
 */
static void			wbrb_cb_list_selected(
GtkWidget			*list,				// (I) ꥹ
gint				row,				// (I) 
gint				column,				// (I) 
GdkEventButton		*event,				// (I) ꥹ
gpointer			call_data			// (I) ̤
)
{
	if (Wbrb_rmflag == FALSE) {
		wbr_set_selected(row, TRUE);
	}
}

/*===============
 *   ̾ : wbrb_cb_list_unselected()
 *     ǽ : ꥹ򥳡Хå
 *    : ʤ
 */
static void			wbrb_cb_list_unselected(
GtkWidget			*list,				// (I) ꥹ
gint				row,				// (I) 
gint				column,				// (I) 
GdkEventButton		*event,				// (I) ꥹ
gpointer			call_data			// (I) ̤
)
{
	if (Wbrb_rmflag == FALSE) {
		wbr_set_selected(row, FALSE);
	}
}

/*===============
 *   ̾ : wbrb_cb_calendar_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_calendar_clicked(
GtkWidget			*entry,				// (I) ܥƥ
gpointer			user_data			// (I) ̤
)
{
	gfloat			now_year;			// ǯ
	gchar			*cal_str;			// ʸ
	gint			loop_cnt;			// 롼ץ

	now_year = GTK_ADJUSTMENT(Wbrb_year)->value
				+ wbr_get_era_year(Wbrb_calendar);
	cal_str = gtk_entry_get_text(GTK_ENTRY(entry));
	for (loop_cnt = 0; loop_cnt < wbr_get_era_num(); loop_cnt++) {
		if (!strcmp(cal_str, wbr_get_era_string(loop_cnt))) {
			now_year -= wbr_get_era_year(loop_cnt);
			Wbrb_calendar = loop_cnt;
			gtk_adjustment_set_value(GTK_ADJUSTMENT(Wbrb_year),
									now_year);
break;
		}
	}
}

/*===============
 *   ̾ : wbrb_cb_add_clicked()
 *     ǽ : ɲåܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_add_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gint			man_cnt;			// ;
	gchar			*user_name;			// ̾
	gint			total_days;			// ̻
	gint			w_year;				// ǯ
	gint			w_month;			// 
	gint			w_day;				// 
	gchar			ymd_string[20];		// ɽ
	gchar			**list_item;		// ꥹȹ

	user_name = gtk_entry_get_text(GTK_ENTRY(Wbrb_name));
	if (user_name[0] != '\0') {
		w_year = GTK_ADJUSTMENT(Wbrb_year)->value
				+ wbr_get_era_year(Wbrb_calendar);
		w_month = GTK_ADJUSTMENT(Wbrb_month)->value;
		w_day = GTK_ADJUSTMENT(Wbrb_day)->value;
		total_days = wmc_get_ymd2days(w_year, w_month, w_day);

		if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
			sprintf(ymd_string, "%d/%02d/%02d", w_year, w_month, w_day);
		}
		else {
			sprintf(ymd_string, "%02d/%02d", w_month, w_day);
		}

		man_cnt = wbr_get_datfile_cnt();
		wbr_set_datfile(user_name, total_days, TRUE, 0);
		list_item = g_malloc(2 * sizeof(gchar *));
		list_item[0] = g_strconcat(user_name, NULL);
		list_item[1] = g_strconcat(ymd_string, NULL);
		gtk_clist_append(GTK_CLIST(Wbrb_list), list_item);
		gtk_clist_select_row(GTK_CLIST(Wbrb_list), man_cnt, 1);
		g_free(list_item[0]);
		g_free(list_item[1]);
		g_free(list_item);

		Wbrb_chg_flag = TRUE;
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTADD);
	}
}

/*===============
 *   ̾ : wbrb_cb_delete_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_delete_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gint			loop_cnt;			// 롼ץ
	gint			sel_cnt;			// 
	gint			dat_cnt;			// ǡ
	gchar			*user_name;			// ̾
	gint			birthday;			// 
	gboolean		item_select;		// 
	gboolean		yes_no;				// γǧ

	sel_cnt = 0;
	dat_cnt = wbr_get_datfile_cnt();
	for (loop_cnt = 0; loop_cnt < dat_cnt; loop_cnt++) {
		item_select = (gboolean)
			wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);
		if (item_select == TRUE) {
			sel_cnt++;
			if (sel_cnt > 1) {
break;
			}
		}
	}

	if (sel_cnt > 0) {
		yes_no = TRUE;
		if (sel_cnt > 1) {
			yes_no = wmc_create_qmsg_dialog(main_window,
						WBR_STR_QUESTION, WBR_STR_QST_SMSEL);
		}

		if (yes_no == TRUE) {
			Wbrb_rmflag = TRUE;
			dat_cnt--;
			for (loop_cnt = dat_cnt; loop_cnt >= 0; loop_cnt--) {
				user_name =
					wbr_get_datfile_item(WBR_MAN_NAME, loop_cnt);
				birthday = (gint)
					wbr_get_datfile_item(WBR_MAN_BIRTHDAY, loop_cnt);
				item_select = (gboolean)
					wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);

				if (item_select == TRUE) {
					wbrb_set_birthday_data(user_name, birthday);
					wbr_delete_datfile(loop_cnt);
					gtk_clist_remove(GTK_CLIST(Wbrb_list), loop_cnt);

					Wbrb_chg_flag = TRUE;
				}
			}
			Wbrb_rmflag = FALSE;
		}
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTSEL);
	}
}

/*===============
 *   ̾ : wbrb_cb_allsel_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_allsel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				call_data			// (I) ̤
)
{
	gtk_clist_select_all(GTK_CLIST(Wbrb_list));
}

/*===============
 *   ̾ : wbrb_cb_allcan_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_allcan_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				call_data			// (I) ̤
)
{
	gtk_clist_unselect_all(GTK_CLIST(Wbrb_list));
}

/*===============
 *   ̾ : wbrb_cb_group_clicked()
 *     ǽ : 롼ץܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_group_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) ϥɥ
)
{
	gboolean		ret_code;			// 
	gboolean		item_change;		// ѹ
	gint			group_num;			// Ͽ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾
	gint			loop_cnt;			// 롼ץ
	gint			man_cnt;			// ;
	gint			user_id;			// 롼ףɣ

	ret_code = wbr_group_main(&item_change, main_window);
	if (item_change == TRUE) {
		Wbrb_chg_flag = TRUE;
	}
	if (ret_code == TRUE) {
		wbr_get_group_info(&group_num, &group_id, &group_name, -1);
		man_cnt = wbr_get_datfile_cnt();
		for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
			user_id = (gint)
				wbr_get_datfile_item(WBR_MAN_GROUPID, loop_cnt);
			if ((group_id & user_id) != 0) {
				wbr_set_selected(loop_cnt, TRUE);
			} else {
				wbr_set_selected(loop_cnt, FALSE);
			}
		}
		wbrb_set_list_data(Wbrb_list);
	}
}

/*===============
 *   ̾ : wbrb_cb_delete_event()
 *     ǽ : ߥܥ󲡲Хå
 *    : FALSE= ˲
 */
static gint			wbrb_cb_delete_event(
GtkWidget			*button,			// (I) ܥ
GdkEvent			*event,				// (I) ٥
gpointer			main_window			// (I) ϥɥ
)
{
	if (Wbrb_chg_flag == TRUE) {
		wbrb_cb_cancel_clicked(button, main_window, 0);
	}

	return FALSE;
}

/*===============
 *   ̾ : wbrb_cb_ok_clicked()
 *     ǽ : ɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		sel_flag = FALSE;	// ե饰
	gint			man_cnt;			// ;
	gchar			*user_name;			// ̾
	gint			birthday;			// 
	gboolean		item_select;		// 

	man_cnt = wbr_get_datfile_cnt();
	for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
		item_select = (gboolean)
			wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);
		if (item_select == TRUE) {
			sel_flag = TRUE;
break;
		}
	}

	if (sel_flag == TRUE) {
		wbr_init_user_info();
		for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
			item_select = (gboolean)
				wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);
			if (item_select == TRUE) {
				user_name =
					wbr_get_datfile_item(WBR_MAN_NAME, loop_cnt);
				birthday = (gint)
					wbr_get_datfile_item(WBR_MAN_BIRTHDAY, loop_cnt);
				wbr_put_user_info(user_name, birthday);
			}
		}
		wbr_put_param(WBR_PRM_ID_CALENDAR, (void *)Wbrb_calendar);
		wbr_write_datfile();

		gtk_widget_destroy(main_window);
		wbr_set_birthday_info();
		wbr_draw_brthm();
	}
	else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_LISTSEL);
	}
}

/*===============
 *   ̾ : wbrb_cb_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrb_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ϥɥ
guint				call_data			// (I) ̤
)
{
	gboolean		yes_no;				// ¸γǧ

	if (Wbrb_chg_flag == TRUE) {
		yes_no = wmc_create_qmsg_dialog(main_window,
					WBR_STR_QUESTION, WBR_STR_QST_SAVE);
		if (yes_no == TRUE) {
			wbr_write_datfile();
		}
	}

	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : wbrb_create_birth_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrb_create_birth_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*list_titles[] = {	// ꥹȹ̾
						WBR_STR_LIST_NAME, WBR_STR_LIST_BIRTH
					};
	GtkWidget		*birth_window;		// ϥɥ
	GtkWidget		*menu_vbox;			//
	GtkWidget		*menu_bar;			// ˥塼С
	GtkWidget		*birth_vbox;		//
	GtkWidget		*title_label;		// ٥
	GtkWidget		*nb_hbox;			//
	GtkWidget		*cal_hbox;			// Ǽܥå
	GtkWidget		*cal_combo;			// 񥳥
	GList			*cal_citem = NULL;	// 񥳥ܹ
	GtkWidget		*cal_centry;		// 񥳥ܹ
	gchar			*cal_str;			// ɽʸ
	gint			loop_cnt;			// 롼ץ
	GtkWidget		*ymd_hbox;			// ǯǼܥå
	GtkWidget		*ymd_label;			// ǯ٥
	GtkWidget		*ymd_spin;			//
	GtkWidget		*list_hbox;			//
	GtkWidget		*list_scrl;			// 륦ɥ
	GtkWidget		*cmd_vbox;			//
	GtkWidget		*cmd_add;			// ɲåܥ
	GtkWidget		*cmd_delete;		// ܥ
	GtkWidget		*cmd_allsel;		// ܥ
	GtkWidget		*cmd_allcan;		// ܥ
	GtkWidget		*cmd_group;			// 롼ץܥ
	GtkWidget		*birth_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// ɽܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ
	GtkAccelGroup	*accel_group;		// 졼

	// ɥ
	title = g_strconcat(WBR_TT_BIRTH, NULL);
	birth_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(birth_window), title);
	gtk_window_set_position(GTK_WINDOW(birth_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(birth_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(birth_window), "delete_event",
					GTK_SIGNAL_FUNC(wbrb_cb_delete_event),
					GTK_OBJECT(birth_window));
	gtk_signal_connect(GTK_OBJECT(birth_window), "destroy",
					GTK_SIGNAL_FUNC(wbrb_cb_destroy), NULL);
	g_free(title);

	// ˥塼
	menu_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(menu_vbox), 1);
	gtk_container_add(GTK_CONTAINER(birth_window), menu_vbox);
	gtk_widget_show(menu_vbox);

	menu_bar = wbrb_create_birth_menu(birth_window);
	gtk_container_add(GTK_CONTAINER(menu_vbox), menu_bar);
	gtk_widget_show(menu_bar);

	// ٥
	birth_vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(birth_vbox), 5);
	gtk_container_add(GTK_CONTAINER(menu_vbox), birth_vbox);
	gtk_widget_show(birth_vbox);

	// ̾
	nb_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(birth_vbox), nb_hbox, FALSE, TRUE, 0);

	title = g_strconcat(WBR_STR_NAME, NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(nb_hbox), title_label, FALSE, TRUE, 0);
	g_free(title);

	Wbrb_name = gtk_entry_new_with_max_length(20);
	gtk_box_pack_start(GTK_BOX(nb_hbox), Wbrb_name, FALSE, TRUE, 0);

	// 
	cal_hbox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(birth_vbox), cal_hbox, FALSE, TRUE, 0);

	cal_combo = gtk_combo_new();
	gtk_box_pack_start(GTK_BOX(cal_hbox), cal_combo, FALSE, TRUE, 0);
	for (loop_cnt = 0; loop_cnt < wbr_get_era_num(); loop_cnt++) {
		cal_str = wbr_get_era_string(loop_cnt);
		cal_citem = g_list_append(cal_citem, cal_str);
	}
	gtk_combo_set_popdown_strings(GTK_COMBO(cal_combo), cal_citem);
	g_list_free(cal_citem);

	cal_centry = GTK_COMBO(cal_combo)->entry;
	cal_str = wbr_get_era_string(Wbrb_calendar);
	gtk_entry_set_text(GTK_ENTRY(cal_centry), cal_str);
	gtk_signal_connect(GTK_OBJECT(cal_centry), "changed",
						GTK_SIGNAL_FUNC(wbrb_cb_calendar_clicked),
						NULL);

	// ǯϥꥢ
	ymd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(cal_hbox), ymd_hbox, TRUE, TRUE, 5);

	Wbrb_year = (GtkAdjustment *)gtk_adjustment_new(0.0, 0.0,
										9999.0, 1.0, 100.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_year, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_YEAR);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	Wbrb_month = (GtkAdjustment *)gtk_adjustment_new(0.0, 1.0,
										12.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_month, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_MONTH);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	Wbrb_day = (GtkAdjustment *)gtk_adjustment_new(0.0, 1.0,
										31.0, 1.0, 5.0, 0.0);
	ymd_spin = gtk_spin_button_new(Wbrb_day, 0, 0);
	gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ymd_spin), TRUE);
	gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ymd_spin),
									GTK_SHADOW_ETCHED_IN);
	gtk_widget_set_usize(ymd_spin, 55, 0);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_spin, FALSE, TRUE, 5);
	ymd_label = gtk_label_new(WBR_STR_DAY);
	gtk_misc_set_alignment(GTK_MISC(ymd_label), 0, 0.5);
	gtk_box_pack_start(GTK_BOX(ymd_hbox), ymd_label, FALSE, TRUE, 2);

	wbrb_set_birthday_data("", wmc_get_today_total());

	// ꥹȥܥå
	list_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(birth_vbox), list_hbox, TRUE, TRUE, 5);

	list_scrl = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(list_scrl), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(list_scrl),
									GTK_POLICY_AUTOMATIC,
									GTK_POLICY_AUTOMATIC);
	gtk_widget_set_usize(GTK_WIDGET(list_scrl), 300, 200);
	gtk_box_pack_start(GTK_BOX(list_hbox), list_scrl, FALSE, TRUE, 20);

	Wbrb_list = gtk_clist_new_with_titles(2, list_titles);
	gtk_clist_set_column_width(GTK_CLIST(Wbrb_list), 0, 150);
	gtk_clist_set_selection_mode(GTK_CLIST(Wbrb_list),
								GTK_SELECTION_EXTENDED);

	wbr_read_datfile();
	wbrb_set_list_data(Wbrb_list);

	gtk_container_add(GTK_CONTAINER(list_scrl), Wbrb_list);
	gtk_signal_connect(GTK_OBJECT(Wbrb_list), "select_row",
						GTK_SIGNAL_FUNC(wbrb_cb_list_selected), NULL);
	gtk_signal_connect(GTK_OBJECT(Wbrb_list), "unselect_row",
						GTK_SIGNAL_FUNC(wbrb_cb_list_unselected), NULL);

	// Խܥ
	cmd_vbox = gtk_vbutton_box_new();
	gtk_box_pack_start(GTK_BOX(list_hbox), cmd_vbox, FALSE, FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(cmd_vbox), 0);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(cmd_vbox),
								GTK_BUTTONBOX_START);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(cmd_vbox), 1);

	cmd_add = gtk_button_new_with_label(WBR_STR_BTN_ADD);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_add);
	gtk_signal_connect(GTK_OBJECT(cmd_add), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_add_clicked),
						GTK_OBJECT(birth_window));

	cmd_delete = gtk_button_new_with_label(WBR_STR_BTN_DELETE);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_delete);
	gtk_signal_connect(GTK_OBJECT(cmd_delete), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_delete_clicked),
						GTK_OBJECT(birth_window));

	birth_sep = gtk_hseparator_new();
	gtk_container_add(GTK_CONTAINER(cmd_vbox), birth_sep);

	cmd_allsel = gtk_button_new_with_label(WBR_STR_BTN_ALLSEL);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_allsel);
	gtk_signal_connect(GTK_OBJECT(cmd_allsel), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_allsel_clicked),
						NULL);

	cmd_allcan = gtk_button_new_with_label(WBR_STR_BTN_ALLCAN);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_allcan);
	gtk_signal_connect(GTK_OBJECT(cmd_allcan), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_allcan_clicked),
						NULL);

	birth_sep = gtk_hseparator_new();
	gtk_container_add(GTK_CONTAINER(cmd_vbox), birth_sep);

	cmd_group = gtk_button_new_with_label(WBR_STR_BTN_GROUP_);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), cmd_group);
	gtk_signal_connect(GTK_OBJECT(cmd_group), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_group_clicked),
						GTK_OBJECT(birth_window));

	// ѥ졼
	birth_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(birth_vbox), birth_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(birth_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_cancel_clicked),
						GTK_OBJECT(birth_window));

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_DISP);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbrb_cb_ok_clicked),
						GTK_OBJECT(birth_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	// 졼
	accel_group = gtk_accel_group_new();
	gtk_widget_add_accelerator(cmd_add, "clicked", accel_group,
							GDK_A, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_delete, "clicked", accel_group,
							GDK_D, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_allsel, "clicked", accel_group,
							GDK_S, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_allcan, "clicked", accel_group,
							GDK_R, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_group, "clicked", accel_group,
							GDK_G, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_V, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_Return, 0, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_C, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_Escape, 0, GTK_ACCEL_VISIBLE);
	gtk_window_add_accel_group(GTK_WINDOW(birth_window), accel_group);

	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(birth_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(birth_window),
									GTK_WINDOW(parent));
	}

	return birth_window;
}

/*===============
 *   ̾ : wbrb_set_birthday_data()
 *     ǽ : ̾Υå
 *    : ʤ
 */
static void			wbrb_set_birthday_data(
gchar				*name,				// (I) ̾
gint				birthday			// (I) 
)
{
	gint			w_year;				// ǯ
	gint			w_month;			// 
	gint			w_day;				// 
	gfloat			ymd_value;			// ǯ

	gtk_entry_set_text(GTK_ENTRY(Wbrb_name), name);

	wmc_get_days2ymd(&w_year, &w_month, &w_day, birthday);
	ymd_value = (gfloat)w_year - wbr_get_era_year(Wbrb_calendar);
	gtk_adjustment_set_value(Wbrb_year, ymd_value);
	ymd_value = (gfloat)w_month;
	gtk_adjustment_set_value(Wbrb_month, ymd_value);
	ymd_value = (gfloat)w_day;
	gtk_adjustment_set_value(Wbrb_day, ymd_value);
}

/*===============
 *   ̾ : wbrb_create_birth_menu()
 *     ǽ : ˥塼
 *    : ˥塼
 */
static GtkWidget	*wbrb_create_birth_menu(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkItemFactoryEntry menu_items[] = {// ˥塼
		{WBR_MN_FILE_, NULL, NULL, 0, "<Branch>"},
		{WBR_MN_FILE WBR_MNF_EXPORT_, "<control>E",
			wbrb_cb_mfile_expimp_clicked, WBR_EITYPE_EXPORT, NULL},
		{WBR_MN_FILE WBR_MNF_IMPORT_, "<control>I",
			wbrb_cb_mfile_expimp_clicked, WBR_EITYPE_IMPORT, NULL},
	};
	gint			nmenu_items;		// ˥塼ܿ
	GtkItemFactory	*item_factory;		//
	GtkAccelGroup	*accel_group;		//

	nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
									"<birth>", accel_group);
	gtk_item_factory_create_items_ac(item_factory,
					nmenu_items, menu_items, parent, 2);

	gtk_accel_group_attach(accel_group, GTK_OBJECT(parent));

	return gtk_item_factory_get_widget(item_factory, "<birth>");
}

/*===============
 *   ̾ : wbrb_set_list_data()
 *     ǽ : ꥹȹ
 *    : ʤ
 */
static void			wbrb_set_list_data(
GtkWidget			*nlist				// (I) ̾ɽꥹ
)
{
	gint			loop_cnt;			// 롼ץ
	gchar			**list_item;		// ꥹȹ
	gint			man_cnt;			// ;
	gchar			*user_name;			// ̾
	gint			birthday;			// 
	gboolean		item_select;		// 
	gchar			temp_date[20];		// ʸ
	gchar			date_fmt[20];		// եեޥå

	gtk_clist_clear(GTK_CLIST(nlist));
	list_item = g_malloc(2 * sizeof(gchar *));
	if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
		strcpy(date_fmt, "%Y/%m/%d");
	}
	else {
		strcpy(date_fmt, "%m/%d");
	}

	man_cnt = wbr_get_datfile_cnt();
	for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
		user_name = wbr_get_datfile_item(WBR_MAN_NAME, loop_cnt);
		birthday = (gint)
			wbr_get_datfile_item(WBR_MAN_BIRTHDAY, loop_cnt);
		item_select = (gboolean)
			wbr_get_datfile_item(WBR_MAN_SELECT, loop_cnt);

		wmc_get_date_string(temp_date, date_fmt, birthday);
		list_item[0] = g_strconcat(user_name, NULL);
		list_item[1] = g_strconcat(temp_date, NULL);
		gtk_clist_append(GTK_CLIST(Wbrb_list), list_item);
		g_free(list_item[0]);
		g_free(list_item[1]);

		if (item_select == TRUE) {
			gtk_clist_select_row(GTK_CLIST(Wbrb_list), loop_cnt, 1);
		}
	}
	g_free(list_item);
}
