/*
 * Хꥺɽե
 *	롼׾μ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_grinfo.c,v 1.1 2002/11/15 09:59:22 tonton Exp $
 */

#include <gtk/gtk.h>
#include <stdlib.h>

#include "brthm.h"
#include "br_sdef.h"

typedef struct {
	gint			user_num;			// Ͽ
	gint			group_id;			// 롼ףɣġʥӥåȡ
	gchar			group_name[41];		// 롼̾
} WBRG_GINFO;

static gint			Wbrg_gindex;		// оݤΥǥåֹ
static WBRG_GINFO	Wbrg_info[WBR_MAX_GROUP];// 롼׾

static gint			wbrg_get_use_group(void);

/*===============
 *   ̾ : wbr_get_group_info()
 *     ǽ : 롼׾μ
 *    : ǥåֹ
 */
gint				wbr_get_group_info(
gint				*user_num,			// (O) Ͽ
gint				*group_id,			// (O) 롼ףɣ
gchar				**group_name,		// (O) 롼̾
gint				group_index			// (I) ǥåֹ
										//	-1 ΤȤϽоݤξ
)
{
	gint			index_no;			// ǥåֹ

	if (group_index == -1) {
		index_no = Wbrg_gindex;
	} else {
		index_no = group_index;
	}
	*user_num = Wbrg_info[index_no].user_num;
	*group_id = Wbrg_info[index_no].group_id;
	*group_name = Wbrg_info[index_no].group_name;

	return index_no;
}

/*===============
 *   ̾ : wbr_put_group_info()
 *     ǽ : 롼׾
 *    : ʤ
 */
void				wbr_put_group_info(
gint				user_num,			// (I) Ͽ
gint				group_id,			// (I) 롼ףɣ
gchar				*group_name,		// (I) 롼̾
gint				group_index			// (I) ǥåֹ
										//	-1 ΤȤϿ
)
{
	gint			loop_cnt;			// 롼ץ
	gint			bit_val;			// ӥå
	gint			use_group;			// ѺѤߥ롼ףɣ

	bit_val = 1;
	if (group_index == -1) {
		use_group = wbrg_get_use_group();
		for (loop_cnt = 0; loop_cnt < WBR_MAX_GROUP; loop_cnt++) {
			if ((bit_val & use_group) == 0) {
				Wbrg_info[loop_cnt].user_num = 0;
				Wbrg_info[loop_cnt].group_id = bit_val;
				strcpy(Wbrg_info[loop_cnt].group_name, group_name);
				Wbrg_gindex = loop_cnt;
break;
			}
			bit_val <<= 1;
		}
	} else {
		Wbrg_info[group_index].user_num = user_num;
		Wbrg_info[group_index].group_id = group_id;
		strcpy(Wbrg_info[group_index].group_name, group_name);
		Wbrg_gindex = group_index;
	}
}

/*===============
 *   ̾ : wbr_get_new_group_id()
 *     ǽ : 롼ףɣĤμ
 *    : 롼ףɣġ-1=ɣĤʤ
 */
gint				wbr_get_new_group_id(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			bit_val;			// ӥå
	gint			group_id;			// 롼ףɣ
	gint			use_group;			// ѺѤߥ롼ףɣ

	bit_val = 1;
	group_id = -1;
	use_group = wbrg_get_use_group();
	for (loop_cnt = 0; loop_cnt < WBR_MAX_GROUP; loop_cnt++) {
		if ((bit_val & use_group) == 0) {
			group_id = loop_cnt;
break;
		}
		bit_val <<= 1;
	}
	wbr_put_group_index(group_id);

	return group_id;
}

/*===============
 *   ̾ : wbr_put_group_index()
 *     ǽ : оݥ롼ֹ
 *    : ʤ
 */
void				wbr_put_group_index(
gint				group_index			// (I) оݤΥ롼ֹ
)
{
	Wbrg_gindex = group_index;
}

/*===============
 *   ̾ : wbr_init_group_info()
 *     ǽ : 롼׾ν
 *    : ʤ
 */
void				wbr_init_group_info(void)
{
	memset(Wbrg_info, 0, sizeof(Wbrg_info));
}

/*===============
 *   ̾ : wbr_read_group_info()
 *     ǽ : 롼׾ɤ߹
 *    : ʤ
 */
void				wbr_read_group_info(
FILE				*infp				// (I/O) եݥ
)
{
	fread(Wbrg_info, sizeof(WBRG_GINFO), WBR_MAX_GROUP, infp);
}

/*===============
 *   ̾ : wbr_write_group_info()
 *     ǽ : 롼׾ν񤭹
 *    : ʤ
 */
void				wbr_write_group_info(
FILE				*outfp				// (I/O) եݥ
)
{
	fwrite(Wbrg_info, sizeof(WBRG_GINFO), WBR_MAX_GROUP, outfp);
}

/*===============
 *   ̾ : wbrg_get_use_group()
 *     ǽ : ѺѤߥ롼ףɣĤμ
 *    : 롼ףɣ
 */
static gint			wbrg_get_use_group(void)
{
	gint			loop_cnt;			// 롼ץ
	gint			use_group;			// ѺѤߥ롼ףɣ

	use_group = 0;
	for (loop_cnt = 0; loop_cnt < WBR_MAX_GROUP; loop_cnt++) {
		use_group |= Wbrg_info[loop_cnt].group_id;
	}

	return use_group;
}
