/*
 * Хꥺɽե
 *	;μ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_user.c,v 1.2 2002/11/15 09:59:22 tonton Exp $
 */

#include <sys/param.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

#define		WBRU_DATFILE	"brthm.dat"
#define		WBRU_FILEVER	2

typedef struct {
	gchar			name[41];			// ̾
	time_t			birthday;			// 
	gboolean		selected;			// 
} WBR_MAN_V1DAT;

typedef struct {
	gchar			name[41];			// ̾
	gint			birthday;			// 
	gboolean		selected;			// 
	gint			group_id;			// 롼ףɣ
} WBR_MAN_DAT;

typedef struct {
	gint			man_cnt;			// 
	WBR_MAN_DAT		*man_dat;			// 
} WBR_MAN_INFO;

static WBR_MAN_INFO	Wbru_man_info;		// ;

static gchar		*wbru_chg_str2csv(gchar *, gchar);
static gchar		*wbru_chg_csv2str(gchar *);

/*===============
 *   ̾ : wbr_get_datfile_cnt()
 *     ǽ : ;μ
 *    : ;
 */
gint				wbr_get_datfile_cnt(void)
{
	return Wbru_man_info.man_cnt;
}

/*===============
 *   ̾ : wbr_get_datfile_item()
 *     ǽ : ;μ
 *    : Ƽ
 */
void				*wbr_get_datfile_item(
gint				item_type,			// (I) ֹ
gint				item_no				// (I) Ǽ
)
{
	void			*ret_value = NULL;	// ͡ʹ͡
	gint			man_cnt;			// ;
	WBR_MAN_DAT		*man_dat;			// ;

	man_cnt = Wbru_man_info.man_cnt;
	if ((item_no >= 0) && (item_no < man_cnt)) {
		man_dat = &Wbru_man_info.man_dat[item_no];
		switch (item_type) {
		case WBR_MAN_NAME:
			ret_value = man_dat->name;
			break;
		case WBR_MAN_BIRTHDAY:
			ret_value = (void *)man_dat->birthday;
			break;
		case WBR_MAN_SELECT:
			ret_value = (void *)man_dat->selected;
			break;
		case WBR_MAN_GROUPID:
			ret_value = (void *)man_dat->group_id;
			break;
		}
	}

	return ret_value;
}

/*===============
 *   ̾ : wbr_set_datfile()
 *     ǽ : ;
 *    : TRUE= ｪλ
 */
gboolean			wbr_set_datfile(
gchar				*name,				// (I) ̾
gint				birthday,			// (I) 
gboolean			selected,			// (I) 
gint				group_id			// (I) 롼ףɣ
)
{
	gboolean		ret_code = TRUE;	// 
	WBR_MAN_DAT		*man_dat;			// ;

	Wbru_man_info.man_cnt++;
	Wbru_man_info.man_dat = g_realloc(Wbru_man_info.man_dat,
					sizeof(WBR_MAN_DAT) * Wbru_man_info.man_cnt);
	man_dat = &Wbru_man_info.man_dat[Wbru_man_info.man_cnt - 1];
	if (*name == '\0') {
		strcpy(man_dat->name, WBR_STR_NONAME);
	}
	else {
		strcpy(man_dat->name, name);
	}
	man_dat->birthday = birthday;
	man_dat->selected = selected;
	man_dat->group_id = group_id;

	return ret_code;
}

/*===============
 *   ̾ : wbr_set_selected()
 *     ǽ : ֤
 *    : ʤ
 */
void				wbr_set_selected(
gint				man_no,				// (I) ꤹֹ
gboolean			selected			// (I) 
)
{
	Wbru_man_info.man_dat[man_no].selected = selected;
}

/*===============
 *   ̾ : wbr_set_group_id()
 *     ǽ : 롼ףɣĤ
 *    : ʤ
 */
void				wbr_set_group_id(
gint				man_no,				// (I) ꤹֹ
gint				group_id			// (I) 롼ףɣ
)
{
	Wbru_man_info.man_dat[man_no].group_id = group_id;
}

/*===============
 *   ̾ : wbr_delete_datfile()
 *     ǽ : ;κ
 *    : TRUE= ｪλ
 */
gboolean			wbr_delete_datfile(
gint				man_no				// (I) ֹ
)
{
	gboolean		ret_code = TRUE;	// 

	Wbru_man_info.man_cnt--;
	memmove(&Wbru_man_info.man_dat[man_no],
			&Wbru_man_info.man_dat[man_no + 1],
			(Wbru_man_info.man_cnt - man_no) * sizeof(WBR_MAN_DAT));
	memset(&Wbru_man_info.man_dat[Wbru_man_info.man_cnt],
							0, sizeof(WBR_MAN_DAT));

	return ret_code;
}

/*===============
 *   ̾ : wbr_free_datfile()
 *     ǽ : ;β
 *    : ʤ
 */
void				wbr_free_datfile(void)
{
	g_free(Wbru_man_info.man_dat);
	memset(&Wbru_man_info, 0, sizeof(WBR_MAN_INFO));
}

/*===============
 *   ̾ : wbr_read_datfile()
 *     ǽ : ;եɤ߹
 *    : TRUE= ｪλ, FALSE= եʤʤ
 */
gboolean			wbr_read_datfile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			loop_cnt;			// 롼ץ
	gint			file_ver;			// եС
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*infp;				// եݥ
	WBR_MAN_DAT		*man_dat;			// ;
	struct tm		*v1tmdate;			// Ver1 եեޥå
	WBR_MAN_V1DAT	v1dat;				// Ver1 ¤

	memset(&Wbru_man_info, 0, sizeof(WBR_MAN_INFO));
	wbr_init_group_info();
	
	strcpy(fname, WBRU_DATFILE);
	infp = fopen(fname, "r");
	if (infp) {
		fread(&file_ver, sizeof(gint), 1, infp);
		if (file_ver == 1) {
			fread(&Wbru_man_info.man_cnt, sizeof(gint), 1, infp);
			Wbru_man_info.man_dat =
				g_malloc0(Wbru_man_info.man_cnt * sizeof(WBR_MAN_DAT));
			man_dat = Wbru_man_info.man_dat;
			for (loop_cnt = 0;
				loop_cnt < Wbru_man_info.man_cnt; loop_cnt++) {
				fread(&v1dat, sizeof(WBR_MAN_V1DAT), 1, infp);
				strcpy(man_dat->name, v1dat.name);
				v1tmdate = localtime(&v1dat.birthday);
				man_dat->birthday =
					wmc_get_ymd2days(v1tmdate->tm_year + 1900,
						v1tmdate->tm_mon + 1, v1tmdate->tm_mday);
				man_dat->selected = v1dat.selected;
				man_dat++;
			}
		} else if (file_ver == 2) {
			wbr_read_group_info(infp);
			fread(&Wbru_man_info.man_cnt, sizeof(gint), 1, infp);
			Wbru_man_info.man_dat =
				g_malloc0(Wbru_man_info.man_cnt * sizeof(WBR_MAN_DAT));
			fread(Wbru_man_info.man_dat, sizeof(WBR_MAN_DAT),
								Wbru_man_info.man_cnt, infp);
		} else {
			g_printerr("%s: Format error\n", fname);
			ret_code = FALSE;
		}

		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbr_write_datfile()
 *     ǽ : ;եν񤭹
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			wbr_write_datfile(void)
{
	gboolean		ret_code = TRUE;	// 
	gint			file_ver;			// եС
	gchar			fname[MAXPATHLEN];	// ե̾
	FILE			*outfp;				// եݥ

	strcpy(fname, WBRU_DATFILE);
	outfp = fopen(fname, "w");
	if (outfp) {
		file_ver = WBRU_FILEVER;
		fwrite(&file_ver, sizeof(gint), 1, outfp);
		wbr_write_group_info(outfp);
		fwrite(&Wbru_man_info.man_cnt, sizeof(gint), 1, outfp);
		fwrite(Wbru_man_info.man_dat, sizeof(WBR_MAN_DAT),
								Wbru_man_info.man_cnt, outfp);

		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbr_export_datfile()
 *     ǽ : ;եΥݡ
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			wbr_export_datfile(
gchar				*fname				// (I) ϥե̾
)
{
	gboolean		ret_code = TRUE;	// 
	gint			loop_cnt;			// 롼ץ
	gchar			delim_char;			// ڤʸ
	gint			col_pos;			// Ͻ
	gchar			birth_str[100];		// 
	FILE			*outfp;				// եݥ
	WBR_MAN_DAT		*man_dat;			// ;

	outfp = fopen(fname, "w");
	if (outfp) {
		delim_char = (gint)wbr_get_param(WBR_PRM_ID_DELIMCHAR);
		col_pos = (gint)wbr_get_param(WBR_PRM_ID_POSITION);
		man_dat = Wbru_man_info.man_dat;
		for (loop_cnt = 0;
			loop_cnt < Wbru_man_info.man_cnt; loop_cnt++) {
			wmc_get_date_string(birth_str,
				"%Y/%m/%d", man_dat->birthday);
			if (col_pos == 0) {
				fprintf(outfp, "%s%c%s\n",
					wbru_chg_str2csv(man_dat->name, delim_char),
					delim_char, birth_str);
			} else {
				fprintf(outfp, "%s%c%s\n",
					birth_str, delim_char,
					wbru_chg_str2csv(man_dat->name, delim_char));
			}
			man_dat++;
		}
		fclose(outfp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbr_import_datfile()
 *     ǽ : ;եΥݡ
 *    : TRUE= ｪλ, FALSE= ѡߥåʤʤ
 */
gboolean			wbr_import_datfile(
gchar				*fname				// (I) ϥե̾
)
{
	gboolean		ret_code = TRUE;	// 
	gint			line_num = 0;		// ɤ߹߹ֹ
	gchar			read_buff[100];		// ɤ߹ߥХåե
	gchar			*sep_pos;			// ѥ졼
	gchar			delim_char;			// ڤʸ
	gchar			delim_work[10];		// ڤʸ
	gint			col_pos;			// Ͻ
	gchar			u_name[100];		// ̾
	gchar			date_str[100];		// 
	gint			w_year;				// ǯ
	gint			w_month;			// 
	gint			w_day;				// 
	gint			birthday;			// 
	FILE			*infp;				// եݥ

	infp = fopen(fname, "r");
	if (infp) {
		delim_char = (gint)wbr_get_param(WBR_PRM_ID_DELIMCHAR);
		col_pos = (gint)wbr_get_param(WBR_PRM_ID_POSITION);
		while (fgets(read_buff, sizeof(read_buff), infp)) {
			line_num++;
			wmc_trim(read_buff);
			if (read_buff[0] == '"') {
				sprintf(delim_work, "\"%c", delim_char);
				sep_pos = strstr(read_buff, delim_work);
				if (sep_pos == NULL) {
					sep_pos = strchr(read_buff, delim_char);
				} else {
					sep_pos++;
				}
			} else {
				sep_pos = strchr(read_buff, delim_char);
			}
			if (sep_pos != NULL) {
				if (col_pos == 0) {
					sprintf(u_name, "%.*s",
						sep_pos - read_buff, read_buff);
					strcpy(date_str, sep_pos + 1);
				} else {
					sprintf(date_str, "%.*s",
						sep_pos - read_buff, read_buff);
					strcpy(u_name, sep_pos + 1);
				}
				strcpy(u_name, wbru_chg_csv2str(u_name));
				wmc_trim(date_str);
				ret_code = wmc_breakup_date(&w_year,
							&w_month, &w_day, date_str);
				if (ret_code == TRUE) {
					birthday = wmc_get_ymd2days(w_year, w_month, w_day);
					wbr_set_datfile(u_name, birthday, TRUE, 0);
				} else {
					g_printerr("Line %d: Format error(%s)\n",
						line_num, read_buff);
				}
			}
		}
		fclose(infp);
	}
	else {
		perror(fname);
		ret_code = FALSE;
	}

	return ret_code;
}

/*===============
 *   ̾ : wbru_chg_str2csv()
 *     ǽ : ʸãӣַ˥եޥå
 *    : Ѵʸ
 */
static gchar		*wbru_chg_str2csv(
gchar				*from_str,			// (I) Ѵʸ
gchar				delim_char			// (I) ڤʸ
)
{
static gchar		to_str[100];		// Ѵʸ
	gchar			*to_pstr;			//
	gboolean		chg_flag;			// Ѵե饰

	chg_flag = FALSE;
	to_pstr = to_str;
	for (; *from_str != '\0'; from_str++) {
		if (*from_str == '"') {
			*(to_pstr++) = *from_str;
			*(to_pstr++) = *from_str;
			chg_flag = TRUE;
		} else {
			if (*from_str == delim_char) {
				chg_flag = TRUE;
			}
			*(to_pstr++) = *from_str;
		}
	}

	if (chg_flag == TRUE) {
		*(to_pstr++) = '"';
		*to_pstr = '\0';
		memmove(&to_str[1], to_str, strlen(to_str));
		to_str[0] = '"';
	} else {
		*to_pstr = '\0';
	}

	return to_str;
}

/*===============
 *   ̾ : wbru_chg_csv2str()
 *     ǽ : ãӣַΥեޥåȤʸѴ
 *    : Ѵʸ
 */
static gchar		*wbru_chg_csv2str(
gchar				*from_str			// (I) Ѵʸ
)
{
static gchar		to_str[100];		// Ѵʸ
	gchar			*to_pstr;			//
	gint			loop_cnt;			// 롼ץ
	gint			from_len;			// ѴʸĹ
	gboolean		chg_flag;			// Ѵե饰
	gboolean		dqt_flag;			// " ե饰

	chg_flag = FALSE;
	dqt_flag = FALSE;
	to_pstr = to_str;

	from_len = strlen(from_str) - 1;
	if ((*from_str == '"') && (from_str[from_len] == '"')) {
		from_str++;
		for (loop_cnt = 1; loop_cnt < from_len; loop_cnt++) {
			if (*from_str == '"') {
				if (dqt_flag == TRUE) {
					dqt_flag = FALSE;
					*(to_pstr++) = *from_str;
				} else {
					dqt_flag = TRUE;
				}
			} else {
				if (dqt_flag == TRUE) {
					*(to_pstr++) = '"';
				}
				*(to_pstr++) = *from_str;
				dqt_flag = FALSE;
			}
			from_str++;
		}
		*to_pstr = '\0';
	} else {
		strcpy(to_str, from_str);
	}

	return to_str;
}
