/*
 * Хꥺɽե
 *	ᥤ󥦥ɥ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_window.c,v 1.3 2002/11/15 09:59:22 tonton Exp $
 */

#include <gtk/gtk.h>
#include <string.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbrw_statusbar = NULL;// ơС
static gboolean		Wbrw_init_flag;		// ե饰

static void			wbrw_cb_window_destroy(void);
static void			wbrw_cb_mview_date_today_clicked(GtkWidget *,
												gpointer, guint);
static void			wbrw_cb_disp_status_change(GtkWidget *,
												gpointer, guint);
static void			wbrw_cb_mview_defcolor_clicked(GtkWidget *,
												gpointer, guint);
static GtkWidget	*wbrw_create_main_menu(GtkWidget *);

/*===============
 *   ̾ : wbr_set_birthday_info()
 *     ǽ : ɽ
 *    : ʤ
 */
void				wbr_set_birthday_info(void)
{
	gint			loop_cnt;			// 롼ץ󥿡
	gint			disp_num;			// ɽͿ
	gchar			user_name[100];		// ̾
	gboolean		year_disp;			// ǯɽ̵ͭ
	gint			birthday;			// 
	gchar			birthday_str[100];	// 
	gchar			*bday_ptr;			// 
	gchar			bday_str[100];		// 
	gchar			temp_bday[100];		// 

	if (Wbrw_statusbar != NULL) {
		disp_num = (gint)wbr_get_user_info(WBR_PRM_ID_BIRTHNUM, 0);
		bday_str[0] = '\0';
		bday_ptr = bday_str;
		year_disp = (gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR);
		for (loop_cnt = 0; loop_cnt < disp_num; loop_cnt++) {
			strcpy(user_name,
				(gchar *)wbr_get_user_info(WBR_PRM_ID_USERNAME,
				loop_cnt));
			birthday = (gint)wbr_get_user_info(WBR_PRM_ID_BIRTHDAY,
														loop_cnt);
			if (year_disp == TRUE) {
				wmc_get_date_string(birthday_str, "%Y/%m/%d", birthday);
			}
			else {
				wmc_get_date_string(birthday_str, "%m/%d", birthday);
			}
			sprintf(temp_bday, "(%d)%s[%s] ",
				loop_cnt + 1, user_name, birthday_str);
			if ((strlen(bday_str) + strlen(temp_bday))
				>= (sizeof(bday_str) - 5)) {
				strncpy(bday_ptr, temp_bday,
					sizeof(bday_str) - strlen(bday_str) - 5);
				strcpy(&bday_str[sizeof(bday_str) - 5], " ...");
break;
			}
			else {
				bday_ptr += sprintf(bday_ptr, "%s", temp_bday);
			}
		}

		gtk_statusbar_pop(GTK_STATUSBAR(Wbrw_statusbar), 1);
		gtk_statusbar_push(GTK_STATUSBAR(Wbrw_statusbar), 1, bday_str);
	}
}

/*===============
 *   ̾ : wbr_create_main_window()
 *     ǽ : ɥ
 *    : ᥤ󥦥ɥ
 */
GtkWidget			*wbr_create_main_window(void)
{
	GtkWidget		*main_window;		// ᥤ󥦥ɥ
	GtkWidget		*main_vbox;			//
	GtkWidget		*menu_handle;		// ˥塼ܥå
	GtkWidget		*menu_bar;			// ˥塼С
	GtkWidget		*draw_area;			// 襨ꥢ
	gchar			*title;				// ȥʸ

	Wbrw_init_flag = FALSE;

	// ᥤ󥦥ɥ
	title = g_strconcat(WBR_TITLE, NULL);
	main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(main_window), title);
	gtk_widget_set_usize(GTK_WIDGET(main_window),
						(gint)wbr_get_param(WBR_PRM_ID_GRAPHWIDTH),
						(gint)wbr_get_param(WBR_PRM_ID_GRAPHHEIGHT));
	gtk_signal_connect(GTK_OBJECT(main_window), "destroy",
						GTK_SIGNAL_FUNC(wbrw_cb_window_destroy),
						NULL);
	gtk_widget_realize(main_window);
	g_free(title);

	// ˥塼С
	main_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(main_vbox), 1);
	gtk_container_add(GTK_CONTAINER(main_window), main_vbox);
	gtk_widget_show(main_vbox);

	menu_handle = gtk_handle_box_new();
	gtk_widget_show(menu_handle);
	gtk_box_pack_start(GTK_BOX(main_vbox), menu_handle, FALSE, TRUE, 0);

	menu_bar = wbrw_create_main_menu(main_window);
	gtk_container_add(GTK_CONTAINER(menu_handle), menu_bar);
	gtk_widget_show(menu_bar);

	// 襨ꥢ
	draw_area = wbr_create_draw_area(main_vbox);
	gtk_widget_show(draw_area);

	// ơС
	Wbrw_statusbar = gtk_statusbar_new();
	gtk_box_pack_start(GTK_BOX(main_vbox),
					Wbrw_statusbar, FALSE, TRUE, 0);
	gtk_widget_show(Wbrw_statusbar);
	wbr_set_birthday_info();

	Wbrw_init_flag = TRUE;
	return main_window;
}

/*===============
 *   ̾ : wbrw_cb_window_destroy()
 *     ǽ : λ
 *    : ʤ
 */
static void			wbrw_cb_window_destroy(void)
{
	wbr_write_inifile();
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrw_cb_mview_date_today_clicked()
 *     ǽ : ɽѹ˥塼κܥ󲡲Хå
 *    : ʤ
 */
static void			wbrw_cb_mview_date_today_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				button_no			// (I) ̤
)
{
	gint			now_date;			// 

	now_date = wmc_get_today_total();
	wbr_put_param(WBR_PRM_ID_DISPDAY, (void *)now_date);
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbrw_cb_disp_status_change()
 *     ǽ : ɽɽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrw_cb_disp_status_change(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				button_no			// (I) ܥֹ
)
{
	gint			button_status;		// ܥ󲡲

	button_status = (gint)wbr_get_param(WBR_PRM_ID_GRAPHDISP);

	button_status ^= button_no;
	wbr_put_param(WBR_PRM_ID_GRAPHDISP, (void *)button_status);

	if (Wbrw_init_flag == TRUE) {
		wbr_draw_brthm();
	}
}

/*===============
 *   ̾ : wbrw_cb_mview_defcolor_clicked()
 *     ǽ : ɸ᤹ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrw_cb_mview_defcolor_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			client_data,		// (I) ̤
guint				call_data			// (I) ̤
)
{
	gint			color_no[] = {		// ֹ
						WBR_PRM_ID_GRAPHFORE,
						WBR_PRM_ID_GRAPHBACK,
						WBR_PRM_ID_GRAPHPHYS,
						WBR_PRM_ID_GRAPHSENS,
						WBR_PRM_ID_GRAPHINTEL
					};
	gint			loop_cnt;			// 롼ץ
	gint			color_num;			// 

	wbr_set_default_color();
	color_num = sizeof(color_no) / sizeof(color_no[0]);
	for (loop_cnt = 0; loop_cnt < color_num; loop_cnt++) {
		wbr_modify_color_gc(color_no[loop_cnt]);
	}
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbrw_create_main_menu()
 *     ǽ : ˥塼
 *    : ˥塼
 */
static GtkWidget	*wbrw_create_main_menu(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkItemFactoryEntry menu_items[] = {// ˥塼
		{WBR_MN_FILE_, NULL, NULL, 0, "<Branch>"},
		{WBR_MN_FILE WBR_MNF_QUIT_, "<control>Q",
			wbrw_cb_window_destroy, 0, NULL},

		{WBR_MN_VIEW_, NULL, NULL, 0, "<Branch>"},
		{WBR_MN_VIEW "/tearoff", NULL, NULL, 0, "<Tearoff>"},
		{WBR_MN_VIEW WBR_MNV_BIRTH_, "<control>H",
			wbr_cb_mview_spcbirth_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{WBR_MN_VIEW WBR_MNV_DATE_, NULL, NULL, 0, "<Branch>"},
		{WBR_MN_VIEW WBR_MNV_DATE_ "/tearoff",
			NULL, NULL, 0, "<Tearoff>"},
		{WBR_MN_VIEW WBR_MNV_DATE WBR_MNVD_TODAY_, "<control>T",
			wbrw_cb_mview_date_today_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{WBR_MN_VIEW WBR_MNV_DATE WBR_MNVD_SPEC_, "<control>R",
			wbr_cb_mview_date_specify_clicked,
			GPOINTER_TO_UINT(parent), NULL},
		{WBR_MN_VIEW "/sep1", NULL, NULL, 0, "<Separator>"},
		{WBR_MN_VIEW WBR_MNV_COLOR_, NULL, NULL, 0, "<Branch>"},
		{WBR_MN_VIEW WBR_MNV_COLOR_ "/tearoff",
			NULL, NULL, 0, "<Tearoff>"},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_FORE_, NULL,
			wbr_cb_mview_color_clicked, WBR_PRM_ID_GRAPHFORE, NULL},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_BACK_, NULL,
			wbr_cb_mview_color_clicked, WBR_PRM_ID_GRAPHBACK, NULL},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_PHYS_, NULL,
			wbr_cb_mview_color_clicked, WBR_PRM_ID_GRAPHPHYS, NULL},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_SENS_, NULL,
			wbr_cb_mview_color_clicked, WBR_PRM_ID_GRAPHSENS, NULL},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_INTEL_, NULL,
			wbr_cb_mview_color_clicked, WBR_PRM_ID_GRAPHINTEL, NULL},
		{WBR_MN_VIEW WBR_MNV_COLOR_ "/sep1", NULL,
			NULL, 0, "<Separator>"},
		{WBR_MN_VIEW WBR_MNV_COLOR_ WBR_MNVC_DEF_, NULL,
			wbrw_cb_mview_defcolor_clicked, 0, NULL},
		{WBR_MN_VIEW WBR_MNV_PHYS_, "<control>P",
			wbrw_cb_disp_status_change, 1, "<CheckItem>"},
		{WBR_MN_VIEW WBR_MNV_SENS_, "<control>S",
			wbrw_cb_disp_status_change, 2, "<CheckItem>"},
		{WBR_MN_VIEW WBR_MNV_INTEL_, "<control>I",
			wbrw_cb_disp_status_change, 4, "<CheckItem>"},
		{WBR_MN_VIEW WBR_MNV_WARN_, "<control>W",
			wbrw_cb_disp_status_change, 8, "<CheckItem>"},
		{WBR_MN_VIEW "/sep2", NULL, NULL, 0, "<Separator>"},
		{WBR_MN_VIEW WBR_MNV_OPTION_, "<control>O",
			wbr_cb_mview_option_clicked,
			GPOINTER_TO_UINT(parent), NULL},

		{WBR_MN_HELP_, NULL, NULL, 0, "<LastBranch>"},
		{WBR_MN_HELP WBR_MNH_ABOUT_, NULL,
			wbr_cb_mhelp_about_clicked, GPOINTER_TO_UINT(parent), NULL},
	};
	gint			nmenu_items;		// ˥塼ܿ
	GtkItemFactory	*item_factory;		//
	GtkAccelGroup	*accel_group;		//
	GtkWidget		*check_item;		// åܥ
	gint			button_status;		// ܥ󲡲

	nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
	accel_group = gtk_accel_group_new();
	item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR,
									"<main>", accel_group);
	gtk_item_factory_create_items_ac(item_factory,
					nmenu_items, menu_items, parent, 2);

	gtk_accel_group_attach(accel_group, GTK_OBJECT(parent));

	button_status = (gint)wbr_get_param(WBR_PRM_ID_GRAPHDISP);
	if ((button_status & WBR_TYPE_PHYS) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									WBR_MN_VIEW WBR_MNV_PHYS);
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_PHYS;
	}
	if ((button_status & WBR_TYPE_SENS) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									WBR_MN_VIEW WBR_MNV_SENS);
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_SENS;
	}
	if ((button_status & WBR_TYPE_INTEL) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									WBR_MN_VIEW WBR_MNV_INTEL);
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_INTEL;
	}
	if ((button_status & WBR_TYPE_WARN) != 0) {
		check_item = gtk_item_factory_get_item(item_factory,
									WBR_MN_VIEW WBR_MNV_WARN);
		gtk_check_menu_item_set_active((GtkCheckMenuItem *)check_item,
																TRUE);
		button_status |= WBR_TYPE_WARN;
	}
	wbr_put_param(WBR_PRM_ID_GRAPHDISP, (void *)button_status);

	return gtk_item_factory_get_widget(item_factory, "<main>");
}
