/*
 * Хꥺɽե
 *	ܤץȥ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: brthm.h,v 1.3 2002/11/15 09:59:22 tonton Exp $
 */

#ifndef BRTHM_H
#define		BRTHM_H

#include <gtk/gtk.h>
#include <stdio.h>

#define		WBR_INTERVAL	5
#define		WBR_CYCLE_PHYS	23
#define		WBR_CYCLE_SENS	28
#define		WBR_CYCLE_INTEL	33

enum {
	WBR_TYPE_PHYS = 1,
	WBR_TYPE_SENS = 2,
	WBR_TYPE_INTEL = 4,
	WBR_TYPE_WARN = 8
};

enum {
	WBR_PRM_ID_USERNAME = 1,
	WBR_PRM_ID_BIRTHDAY,
	WBR_PRM_ID_DISPPERIOD,
	WBR_PRM_ID_BIRTHYEAR,
	WBR_PRM_ID_DISPTOTAL,
	WBR_PRM_ID_CALENDAR,

	WBR_PRM_ID_GRAPHPOINT,
	WBR_PRM_ID_GRAPHWIDTH,
	WBR_PRM_ID_GRAPHHEIGHT,
	WBR_PRM_ID_LINEWIDTH,
	WBR_PRM_ID_GRAPHDISP,
	WBR_PRM_ID_DAYLINE,
	WBR_PRM_ID_FULLDAY,
	WBR_PRM_ID_GRAPHFORE,
	WBR_PRM_ID_GRAPHBACK,
	WBR_PRM_ID_GRAPHPHYS,
	WBR_PRM_ID_GRAPHSENS,
	WBR_PRM_ID_GRAPHINTEL,

	WBR_PRM_ID_DISPDAY,
	WBR_PRM_ID_BIRTHNUM,

	WBR_PRM_ID_DELIMCHAR,
	WBR_PRM_ID_POSITION
};

enum {
	WBR_MAN_NAME,
	WBR_MAN_BIRTHDAY,
	WBR_MAN_SELECT,
	WBR_MAN_GROUPID
};

enum {
	WBR_EITYPE_EXPORT,
	WBR_EITYPE_IMPORT
};

enum {
	WBR_GRP_NEW,
	WBR_GRP_EDIT
};
// 32 ӥåȥѥξϡ32 ʲꤷƤ
#define		WBR_MAX_GROUP		30		// 롼׺Ͽ

// br_window.c
extern void			wbr_set_birthday_info(void);
extern GtkWidget	*wbr_create_main_window(void);

// br_draw.c
extern void			wbr_init_psi_table(void);
extern void			wbr_draw_brthm(void);
extern void			wbr_modify_color_gc(gint);
extern GtkWidget	*wbr_create_draw_area(GtkWidget *);

// br_birth.c
extern void			wbr_cb_mview_spcbirth_clicked(GtkWidget *,
												gpointer, guint);

// br_user.c
extern gint			wbr_get_datfile_cnt(void);
extern void			*wbr_get_datfile_item(gint, gint);
extern gboolean		wbr_set_datfile(gchar *, gint, gboolean, gint);
extern void			wbr_set_selected(gint, gboolean);
extern void			wbr_set_group_id(gint, gint);
extern gboolean		wbr_delete_datfile(gint);
extern void			wbr_free_datfile(void);
extern gboolean		wbr_read_datfile(void);
extern gboolean		wbr_write_datfile(void);
extern gboolean		wbr_export_datfile(gchar *);
extern gboolean		wbr_import_datfile(gchar *);

// br_idate.c
extern void			wbr_cb_mview_date_specify_clicked(GtkWidget *,
												gpointer, guint);

// br_color.c
extern void			wbr_cb_mview_color_clicked(GtkWidget *,
												gpointer, guint);

// br_option.c
extern void			wbr_cb_mview_option_clicked(GtkWidget *,
												gpointer, guint);

// br_about.c
extern void			wbr_cb_mhelp_about_clicked(GtkWidget *,
												gpointer, guint);

// br_param.c
extern void			*wbr_get_param(gint);
extern void			wbr_put_param(gint, void *);
extern void			wbr_init_user_info(void);
extern void			*wbr_get_user_info(gint, gint);
extern void			wbr_put_user_info(gchar *, gint);
extern gchar		*wbr_get_era_string(gint);
extern gint			wbr_get_era_year(gint);
extern gint			wbr_get_era_num(void);
extern void			wbr_set_default_color(void);
extern gboolean		wbr_read_inifile(void);
extern gboolean		wbr_write_inifile(void);

// br_expimp.c
extern void			wbr_expimp_main(GtkWidget *, gint);

// br_grmain.c
extern gboolean		wbr_group_main(gboolean *, GtkWidget *);

// br_gredit.c
extern gboolean		wbr_gedit_main(GtkWidget *, gboolean);

// br_grinfo.c
extern gint			wbr_get_group_info(gint *, gint *, gchar **, gint);
extern void			wbr_put_group_info(gint, gint, gchar *, gint);
extern gint			wbr_get_new_group_id(void);
extern void			wbr_put_group_index(gint);
extern void			wbr_init_group_info(void);
extern void			wbr_read_group_info(FILE *);
extern void			wbr_write_group_info(FILE *);

#endif /* BRTHM_H */
