/*
 * ̴ؿ
 *	ؿ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: wmc_draw.c,v 1.2 2000/08/25 11:50:32 tonton Exp $
 */

#include <gtk/gtk.h>
#include <ctype.h>

#include "wmc_sdef.h"
#include "wmc_ptype.h"

/*===============
 *   ̾ : wmc_gdk_draw_text()
 *     ǽ : ʸ
 *    : ʤ
 */
void				wmc_gdk_draw_text(
GdkPixmap			*draw_area,			// (I) 襨ꥢ
GdkFont				*ascii_font,		// (I) ե
GdkFont				*kanji_font,		// (I) ե
GdkGC				*gc_color,			// (I) ɽ
gint				pos_x,				// (I) ɽɸ
gint				pos_y,				// (I) ɽɸ
gchar				*put_str,			// (I) ɽʸ
gint				put_len				// (I) ɽʸĹ
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		asc_kan;			// 
	gboolean		cur_asc_kan;		// 
	gint			true_len;			// ϤʸĹ
	gchar			*put_ptr;			// ɽϰ

	if (*put_str) {
		put_ptr = put_str;
		true_len = 0;
		asc_kan = isascii(*put_str);
		if (asc_kan == TRUE) {
			loop_cnt = 1;
			true_len = 1;
		}
		else {
			loop_cnt = 2;
			true_len = 2;
		}
		for (; loop_cnt < put_len; loop_cnt++) {
			cur_asc_kan = isascii(put_str[loop_cnt]);
			if (asc_kan != cur_asc_kan) {
				if (asc_kan == TRUE) {
					gdk_draw_text(draw_area, 
								ascii_font, gc_color,
								pos_x, pos_y, put_ptr, true_len);
					pos_x +=
						gdk_text_width(ascii_font, put_ptr, true_len);
					put_ptr += true_len;
					true_len = 2;
					loop_cnt++;
				}
				else {
					gdk_draw_text(draw_area, 
								kanji_font, gc_color,
								pos_x, pos_y, put_ptr, true_len);
					pos_x +=
						gdk_text_width(kanji_font, put_ptr, true_len);
					put_ptr += true_len;
					true_len = 1;
				}
				asc_kan = cur_asc_kan;
			}
			else {
				if (asc_kan == TRUE) {
					true_len++;
				}
				else {
					true_len += 2;
					loop_cnt++;
				}
			}
		}

		if (true_len) {
			if (asc_kan == TRUE) {
				gdk_draw_text(draw_area, 
							ascii_font, gc_color,
							pos_x, pos_y, put_ptr, true_len);
			}
			else {
				gdk_draw_text(draw_area, 
							kanji_font, gc_color,
							pos_x, pos_y, put_ptr, true_len);
			}
		}
	}
}

/*===============
 *   ̾ : wmc_gdk_text_width()
 *     ǽ : ʸĹμ
 *    : ʸĹ
 */
gint				wmc_gdk_text_width(
GdkFont				*ascii_font,		// (I) ե
GdkFont				*kanji_font,		// (I) ե
gchar				*put_str,			// (I) ɽʸ
gint				put_len				// (I) ɽʸĹ
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		asc_kan;			// 
	gboolean		cur_asc_kan;		// 
	gint			true_len;			// ϤʸĹ
	gint			text_width;			// ʸĹ
	gchar			*put_ptr;			// ɽϰ

	text_width = 0;
	if (*put_str) {
		put_ptr = put_str;
		true_len = 0;
		asc_kan = isascii(*put_str);
		if (asc_kan == TRUE) {
			loop_cnt = 1;
			true_len = 1;
		}
		else {
			loop_cnt = 2;
			true_len = 2;
		}
		for (; loop_cnt < put_len; loop_cnt++) {
			cur_asc_kan = isascii(put_str[loop_cnt]);
			if (asc_kan != cur_asc_kan) {
				if (asc_kan == TRUE) {
					text_width += gdk_text_width(ascii_font,
											put_ptr, true_len);
					put_ptr += true_len;
					true_len = 2;
					loop_cnt++;
				}
				else {
					text_width += gdk_text_width(kanji_font,
											put_ptr, true_len);
					put_ptr += true_len;
					true_len = 1;
				}
				asc_kan = cur_asc_kan;
			}
			else {
				if (asc_kan == TRUE) {
					true_len++;
				}
				else {
					true_len += 2;
					loop_cnt++;
				}
			}
		}

		if (true_len) {
			if (asc_kan == TRUE) {
				text_width += gdk_text_width(ascii_font,
										put_ptr, true_len);
			}
			else {
				text_width += gdk_text_width(kanji_font,
										put_ptr, true_len);
			}
		}
	}

	return text_width;
}

/*===============
 *   ̾ : wmc_gdk_text_height()
 *     ǽ : ʸ⤵μ
 *    : ʸ⤵(Ĺ)
 */
gint				wmc_gdk_text_height(
GdkFont				*ascii_font,		// (I) ե
GdkFont				*kanji_font,		// (I) ե
gchar				*put_str,			// (I) ɽʸ
gint				put_len				// (I) ɽʸĹ
)
{
	gint			loop_cnt;			// 롼ץ
	gboolean		asc_kan;			// 
	gboolean		cur_asc_kan;		// 
	gint			true_len;			// ϤʸĹ
	gint			text_height;		// ʸ⤵
	gint			temp_height;		// ʸ⤵
	gchar			*put_ptr;			// ɽϰ

	text_height = 0;
	if (*put_str) {
		put_ptr = put_str;
		true_len = 0;
		asc_kan = isascii(*put_str);
		if (asc_kan == TRUE) {
			loop_cnt = 1;
			true_len = 1;
		}
		else {
			loop_cnt = 2;
			true_len = 2;
		}
		for (; loop_cnt < put_len; loop_cnt++) {
			cur_asc_kan = isascii(put_str[loop_cnt]);
			if (asc_kan != cur_asc_kan) {
				if (asc_kan == TRUE) {
					temp_height = gdk_text_height(ascii_font,
											put_ptr, true_len);
					put_ptr += true_len;
					true_len = 2;
					loop_cnt++;
				}
				else {
					temp_height = gdk_text_height(kanji_font,
											put_ptr, true_len);
					put_ptr += true_len;
					true_len = 1;
				}
				if (temp_height > text_height) {
					text_height = temp_height;
				}
				asc_kan = cur_asc_kan;
			}
			else {
				if (asc_kan == TRUE) {
					true_len++;
				}
				else {
					true_len += 2;
					loop_cnt++;
				}
			}
		}

		if (true_len) {
			if (asc_kan == TRUE) {
				temp_height = gdk_text_height(ascii_font,
										put_ptr, true_len);
			}
			else {
				temp_height = gdk_text_height(kanji_font,
										put_ptr, true_len);
			}
			if (temp_height > text_height) {
				text_height = temp_height;
			}
		}
	}

	return text_height;
}
