/*
 * Хꥺɽե
 *	ɽ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: br_color.c,v 1.1 2000/06/28 01:08:00 tonton Exp $
 */

#include <gtk/gtk.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static gint			Wbrc_color_no;		// ֹ	

static GtkWidget	*wbrc_create_color_window(GtkWidget *);
static void			wbrc_cb_ok_clicked(GtkWidget *, gpointer, guint);

/*===============
 *   ̾ : wbr_cb_mview_color_clicked()
 *     ǽ : 򥦥ɥκ
 *    : ʤ
 */
void				wbr_cb_mview_color_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ᥤ󥦥ɥ
guint				color_no			// (I) ֹ
)
{
	GtkWidget		*color_window;		// 򥦥ɥ

	Wbrc_color_no = color_no;
	color_window =
		wbrc_create_color_window(GUINT_TO_POINTER(main_window));
	gtk_widget_show_all(color_window);
}

/*===============
 *   ̾ : wbrc_cb_ok_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrc_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window,		// (I) ץꥦɥ
guint				call_data			// (I) ̤
)
{
	GtkColorSelectionDialog
					*color_window;		// 򥦥ɥ
	GtkColorSelection	*colorsel;		//
	GdkColor		prm_color;			// ꤹ뿧
	gdouble			spc_color[4];		// 򤷤

	color_window = (GtkColorSelectionDialog *)main_window;
	colorsel = GTK_COLOR_SELECTION(color_window->colorsel);
	gtk_color_selection_get_color(colorsel, spc_color);

	memset(&prm_color, 0, sizeof(GdkColor));
	prm_color.red = (guint)(spc_color[0] * (guint)0xffff);
	prm_color.green = (guint)(spc_color[1] * (guint)0xffff);
	prm_color.blue = (guint)(spc_color[2] * (guint)0xffff);
	wbr_put_param(Wbrc_color_no, &prm_color);

	gtk_widget_destroy(main_window);
	wbr_modify_color_gc(Wbrc_color_no);
	wbr_draw_brthm();
}

/*===============
 *   ̾ : wbrc_create_color_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrc_create_color_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*color_window;		// ɥ
	GtkColorSelection	*colorsel;		//
	GdkColor		*prm_color;			// ꤵƤ뿧
	gdouble			spc_color[4];		// ꤹ뿧
	GtkWidget		*cmd_ok;			// ܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ

	// ɥ
	title = g_strconcat(WBR_TT_COLOR, NULL);
	color_window = gtk_color_selection_dialog_new(title);
	gtk_window_set_position(GTK_WINDOW(color_window),
							GTK_WIN_POS_MOUSE);
	gtk_container_set_border_width(GTK_CONTAINER(color_window), 10);
	g_free(title);

	// 
	prm_color = wbr_get_param(Wbrc_color_no);
	spc_color[0] = (gdouble)prm_color->red / (guint)0xffff;
	spc_color[1] = (gdouble)prm_color->green / (guint)0xffff;
	spc_color[2] = (gdouble)prm_color->blue / (guint)0xffff;
	colorsel = GTK_COLOR_SELECTION(((GtkColorSelectionDialog *)color_window)->colorsel);
	gtk_color_selection_set_color(colorsel, spc_color);

	// ܥ
	cmd_ok = GTK_COLOR_SELECTION_DIALOG(color_window)->ok_button;
	gtk_widget_show(cmd_ok);
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbrc_cb_ok_clicked),
						GTK_OBJECT(color_window));

	cmd_cancel = GTK_COLOR_SELECTION_DIALOG(color_window)->cancel_button;
	gtk_widget_show(cmd_cancel);
	GTK_WIDGET_SET_FLAGS(cmd_cancel, GTK_CAN_DEFAULT);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wmc_dialog_close_clicked),
						GTK_OBJECT(color_window));

	gtk_widget_grab_default(cmd_ok);

	gtk_window_set_modal(GTK_WINDOW(color_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(color_window),
								GTK_WINDOW(parent));

	return color_window;
}
