/*
 * Хꥺɽե
 *	ݡȡݡȽ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_expimp.c,v 1.1 2002/11/15 09:59:22 tonton Exp $
 */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string.h>
#include <unistd.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbre_fsel;			// ե򥦥ɥ
static gchar		*Wbre_eifile;		// ϡϡ˥ե
static GtkWidget	*Wbre_sepoth;		// ڤʸʤ¾
static gboolean		Wbre_eitype;		// ݡȡݡ
static gint			Wbre_delimchar;		// ڤʸ
static gint			Wbre_position;		// Ͻ

static void			wbre_cb_destroy(void);
static void			wbre_cb_fs_ok_clicked(GtkWidget *,
										GtkFileSelection *);
static void			wbre_cb_fs_cancel_clicked(GtkWidget *, gpointer);
static void			wbre_cb_delimchar_clicked(GtkWidget *, gpointer);
static void			wbre_cb_delim_changed(GtkWidget *, gpointer);
static void			wbre_cb_position_clicked(GtkWidget *, gpointer);
static void			wbre_cb_ei_ok_clicked(GtkWidget *, gpointer);
static void			wbre_cb_ei_cancel_clicked(GtkWidget *, gpointer);
static GtkWidget	*wbre_create_fsel_window(GtkWidget *, gchar *);
static GtkWidget	*wbre_create_expimp_window(GtkWidget *);

/*===============
 *   ̾ : wbr_expimp_main()
 *     ǽ : ɥ
 *    : 0= ｪλ
 */
void				wbr_expimp_main(
GtkWidget			*parent,			// (I) ƥɥ
gboolean			ei_type				// (I) ݡȡݡ
)
{
	GtkWidget		*ei_window;			// ɥ

	Wbre_eitype = ei_type;

	// ե
	Wbre_fsel = wbre_create_fsel_window(parent, Wbre_eifile);
	gtk_widget_show_all(Wbre_fsel);
	gtk_main();

	// 
	if (Wbre_eifile != NULL) {
		Wbre_delimchar = (gint)wbr_get_param(WBR_PRM_ID_DELIMCHAR);
		Wbre_position = (gint)wbr_get_param(WBR_PRM_ID_POSITION);

		ei_window = wbre_create_expimp_window(parent);
		gtk_widget_show_all(ei_window);
		gtk_main();
	}
}
/*===============
 *   ̾ : wbre_cb_fs_ok_clicked()
 *     ǽ : λܥ󲡲Хåʥե
 *    : ʤ
 */
static void			wbre_cb_fs_ok_clicked(
GtkWidget			*button,			// (I) ܥ
GtkFileSelection	*file_sel			// (I) 
)
{
	gboolean		write_ok;			// 񤭹ߥե饰

	Wbre_eifile = strdup(gtk_file_selection_get_filename(
							GTK_FILE_SELECTION(Wbre_fsel)));

	if (Wbre_eitype == WBR_EITYPE_EXPORT) {
		write_ok = TRUE;
		if (access(Wbre_eifile, R_OK) >= 0) {
			write_ok = wmc_create_qmsg_dialog(Wbre_fsel,
						WBR_STR_QUESTION, WBR_STR_QST_OWRITE);
		}
		if (write_ok != TRUE) {
			g_free(Wbre_eifile);
			Wbre_eifile = NULL;
		}
	}

	gtk_widget_destroy(Wbre_fsel);
}

/*===============
 *   ̾ : wbre_cb_fs_cancel_clicked()
 *     ǽ : åܥ󲡲Хåʥե
 *    : ʤ
 */
static void			wbre_cb_fs_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			fs_window			// (I) ɥ
)
{
	if (Wbre_eifile != NULL) {
		g_free(Wbre_eifile);
		Wbre_eifile = NULL;
	}
	gtk_widget_destroy(fs_window);
}

/*===============
 *   ̾ : wbre_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			wbre_cb_destroy(void)
{
	gtk_main_quit();
}

/*===============
 *   ̾ : wbre_cb_delimchar_clicked()
 *     ǽ : եɶڤ국򥳡Хå
 *    : ʤ
 */
static void			wbre_cb_delimchar_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			delim_char			// (I) ڤʸ
)
{
	gboolean		is_active;			// ܥ󲡲
	gchar			*delim_work;		// ڤʸ

	is_active = GTK_TOGGLE_BUTTON(button)->active;
	if (is_active == TRUE) {
		if (delim_char == NULL) {
			delim_work = gtk_entry_get_text(GTK_ENTRY(Wbre_sepoth));
		} else {
			delim_work = delim_char;
		}
		Wbre_delimchar = delim_work[0];
	}
}

/*===============
 *   ̾ : wbre_cb_delim_changed()
 *     ǽ : եɶڤ국ƥѹХå
 *    : ʤ
 */
static void			wbre_cb_delim_changed(
GtkWidget			*textentry,			// (I) ƥ
gpointer			button				// (I) ¾ܥ
)
{
	gchar			*delim_work;		// ڤʸ

	delim_work = gtk_entry_get_text(GTK_ENTRY(Wbre_sepoth));
	Wbre_delimchar = delim_work[0];

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
}

/*===============
 *   ̾ : wbre_cb_position_clicked()
 *     ǽ : Ͻ򥳡Хå
 *    : ʤ
 */
static void			wbre_cb_position_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			position			// (I) Ͻ
)
{
	gboolean		is_active;			// ܥ󲡲

	is_active = GTK_TOGGLE_BUTTON(button)->active;
	if (is_active == TRUE) {
		Wbre_position = (gint)position;
	}
}

/*===============
 *   ̾ : wbre_cb_ei_ok_clicked()
 *     ǽ : ¹ԥܥ󲡲Хå
 *    : ʤ
 */
static void			wbre_cb_ei_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			ei_window			// (I) ɥ
)
{
	gboolean		ret_code;			// 

	wbr_put_param(WBR_PRM_ID_DELIMCHAR, (void *)Wbre_delimchar);
	wbr_put_param(WBR_PRM_ID_POSITION, (void *)Wbre_position);

	if (Wbre_eitype == WBR_EITYPE_EXPORT) {
		wbr_export_datfile(Wbre_eifile);
	} else if (Wbre_eitype == WBR_EITYPE_IMPORT) {
		ret_code = wbr_import_datfile(Wbre_eifile);
		if (ret_code == FALSE) {
			wmc_create_emsg_dialog(ei_window,
				WBR_STR_ERROR, WBR_STR_ERR_IMPORT);
		}
	}

	gtk_widget_destroy(ei_window);
}

/*===============
 *   ̾ : wbre_cb_ei_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbre_cb_ei_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			ei_window			// (I) ɥ
)
{
	gtk_widget_destroy(ei_window);
}

/*===============
 *   ̾ : wbre_create_fsel_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbre_create_fsel_window(
GtkWidget			*parent,			// (I) ƥɥ
gchar				*file_name			// (I) ɽե̾
)
{
	GtkWidget		*fsel_window;		// ɥ
	GtkObject		*cmd_ok;			// λܥ
	GtkObject		*cmd_cancel;		// åܥ

	// ɥ
	fsel_window = gtk_file_selection_new("");
	gtk_signal_connect(GTK_OBJECT(fsel_window), "destroy",
					GTK_SIGNAL_FUNC(wbre_cb_destroy), NULL);

	// ܥ
	cmd_ok = GTK_OBJECT(GTK_FILE_SELECTION(fsel_window)->ok_button);
	gtk_signal_connect(cmd_ok, "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_fs_ok_clicked),
						GTK_OBJECT(fsel_window));

	cmd_cancel =
		GTK_OBJECT(GTK_FILE_SELECTION(fsel_window)->cancel_button);
	gtk_signal_connect(cmd_cancel, "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_fs_cancel_clicked),
						GTK_OBJECT(fsel_window));

	if (file_name != NULL) {
		gtk_file_selection_set_filename(GTK_FILE_SELECTION(fsel_window),
															file_name);
	}

	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(fsel_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(fsel_window),
									GTK_WINDOW(parent));
	}

	return fsel_window;
}

/*===============
 *   ̾ : wbre_create_expimp_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbre_create_expimp_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*ei_window;			// ɥ
	gchar			*title;				// ȥʸ
	GtkWidget		*ei_vbox;			//
	GtkWidget		*dlm_fram;			// եɶڤ국
	GtkWidget		*dlm_hbox;			//
	GSList			*dlm_group = NULL;	// եɶڤ국楰롼
	GtkWidget		*dlm_btn;			// եɶڤ국ܥ
	gchar			work_delim[2];		// ڤ국
	GtkWidget		*pos_fram;			// Ͻ
	GtkWidget		*pos_hbox;			//
	GSList			*pos_group = NULL;	// Ͻ֥롼
	GtkWidget		*pos_btn;			// Ͻ֥ܥ
	GtkWidget		*ei_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			//
	GtkWidget		*cmd_ok;			// ¹ԥܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	GtkAccelGroup	*accel_group;		// 졼

	// ɥ
	title = g_strconcat(WBR_TT_EXPIMP, NULL);
	ei_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(ei_window), title);
	gtk_window_set_position(GTK_WINDOW(ei_window), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(ei_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(ei_window), "destroy",
					GTK_SIGNAL_FUNC(wbre_cb_destroy), NULL);
	g_free(title);

	// եɶڤ국
	ei_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(ei_vbox), 5);
	gtk_container_add(GTK_CONTAINER(ei_window), ei_vbox);

	dlm_fram = gtk_frame_new(WBR_STR_DELIMCHAR);
	gtk_box_pack_start(GTK_BOX(ei_vbox), dlm_fram, FALSE, TRUE, 0);

	dlm_hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(dlm_fram), dlm_hbox);

	// 
	dlm_btn = gtk_radio_button_new_with_label(NULL, WBR_STR_COMMA);
	if (Wbre_delimchar == ',') {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(dlm_btn), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(dlm_hbox), dlm_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(dlm_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_delimchar_clicked),
						(gpointer)",");
	// 
	dlm_group = gtk_radio_button_group(GTK_RADIO_BUTTON(dlm_btn));
	dlm_btn = gtk_radio_button_new_with_label(dlm_group, WBR_STR_TAB);
	if (Wbre_delimchar == '\t') {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(dlm_btn), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(dlm_hbox), dlm_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(dlm_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_delimchar_clicked),
						(gpointer)"\t");
	// ڡ
	dlm_group = gtk_radio_button_group(GTK_RADIO_BUTTON(dlm_btn));
	dlm_btn = gtk_radio_button_new_with_label(dlm_group, WBR_STR_SPACE);
	if (Wbre_delimchar == ' ') {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(dlm_btn), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(dlm_hbox), dlm_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(dlm_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_delimchar_clicked),
						(gpointer)" ");
	// ¾
	dlm_group = gtk_radio_button_group(GTK_RADIO_BUTTON(dlm_btn));
	dlm_btn = gtk_radio_button_new_with_label(dlm_group, WBR_STR_OTHER);
	gtk_box_pack_start(GTK_BOX(dlm_hbox), dlm_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(dlm_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_delimchar_clicked),
						NULL);

	Wbre_sepoth = gtk_entry_new_with_max_length(1);
	gtk_box_pack_start(GTK_BOX(dlm_hbox), Wbre_sepoth, FALSE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(Wbre_sepoth), "changed",
						GTK_SIGNAL_FUNC(wbre_cb_delim_changed),
						(gpointer)dlm_btn);
	if ((Wbre_delimchar != ',')
		&& (Wbre_delimchar != '\t') && (Wbre_delimchar != ' ')) {
		sprintf(work_delim, "%c", Wbre_delimchar);
		gtk_entry_set_text(GTK_ENTRY(Wbre_sepoth), work_delim);
	}

	// Ͻ
	pos_fram = gtk_frame_new(WBR_STR_POSITION);
	gtk_box_pack_start(GTK_BOX(ei_vbox), pos_fram, FALSE, TRUE, 0);

	pos_hbox = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(pos_fram), pos_hbox);

	// ̾
	pos_btn = gtk_radio_button_new_with_label(NULL, WBR_STR_NAMEBIRTH);
	if (Wbre_position == 0) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pos_btn), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(pos_hbox), pos_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(pos_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_position_clicked),
						(gpointer)0);
	// ̾
	pos_group = gtk_radio_button_group(GTK_RADIO_BUTTON(pos_btn));
	pos_btn = gtk_radio_button_new_with_label(pos_group,
										WBR_STR_BIRTHNAME);
	if (Wbre_position == 1) {
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pos_btn), TRUE);
	}
	gtk_box_pack_start(GTK_BOX(pos_hbox), pos_btn, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(pos_btn), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_position_clicked),
						(gpointer)1);

	// ѥ졼
	ei_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(ei_vbox), ei_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(ei_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_ei_cancel_clicked),
						GTK_OBJECT(ei_window));

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_EXEC);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbre_cb_ei_ok_clicked),
						GTK_OBJECT(ei_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(cmd_ok);

	// 졼
	accel_group = gtk_accel_group_new();
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_E, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_Return, 0, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_C, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_Escape, 0, GTK_ACCEL_VISIBLE);
	gtk_window_add_accel_group(GTK_WINDOW(ei_window), accel_group);

	gtk_window_set_modal(GTK_WINDOW(ei_window), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(ei_window),
								GTK_WINDOW(parent));

	return ei_window;
}
