/*
 * Хꥺɽե
 *	롼Խ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_gredit.c,v 1.1 2002/11/15 09:59:22 tonton Exp $
 */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbrg_gname;		// 롼̾
static GtkWidget	*Wbrg_list;			// ꥹ
static gboolean		Wbrg_disp_flag;		// ̼ե饰
static gboolean		Wbrg_chg_flag;		// ѹե饰

static void			wbrg_cb_destroy(void);
static void			wbrg_cb_ok_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_cancel_clicked(GtkWidget *, gpointer);
static GtkWidget	*wbrg_create_gedit_window(GtkWidget *);
static void			wbrg_set_list_data(GtkWidget *, GtkWidget *);

/*===============
 *   ̾ : wbr_gedit_main()
 *     ǽ : 롼Խɥκ
 *    : ʤ
 */
gboolean			wbr_gedit_main(
GtkWidget			*parent,			// (I) ƥɥ
gboolean			disp_flag			// (I) ̼
)
{
	GtkWidget		*gedit_window;		// 롼Խɥ

	Wbrg_disp_flag = disp_flag;
	Wbrg_chg_flag = FALSE;
	gedit_window = wbrg_create_gedit_window(parent);
	gtk_widget_show_all(gedit_window);
	gtk_main();

	return Wbrg_chg_flag;
}

/*===============
 *   ̾ : wbrg_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			wbrg_cb_destroy(void)
{
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrg_cb_ok_clicked()
 *     ǽ : Ͽܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_ok_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼Խɥ
)
{
	gint			group_num;			// 롼Ͽ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾
	gchar			*new_gname;			// 롼̾
	gint			group_index;		// 롼ץǥåֹ
	gint			loop_cnt;			// 롼ץ
	gint			man_cnt;			// ;
	gint			user_id;			// 롼ףɣ
	GList			*list_sel;			// ꥹ
	gint			sel_row;			// ֹ

	new_gname = gtk_entry_get_text(GTK_ENTRY(Wbrg_gname));
	if (new_gname[0] != '\0') {
		if (Wbrg_disp_flag == WBR_GRP_NEW) {
			wbr_put_group_info(0, 0, new_gname, -1);
		}
		group_index = wbr_get_group_info(&group_num,
							&group_id, &group_name, -1);
		man_cnt = wbr_get_datfile_cnt();
		for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
			user_id = (gint)
				wbr_get_datfile_item(WBR_MAN_GROUPID, loop_cnt);
			user_id |= group_id;
			user_id ^= group_id;
			wbr_set_group_id(loop_cnt, user_id);
		}

		group_num = 0;
		list_sel = GTK_CLIST(Wbrg_list)->selection;
		while (list_sel) {
			sel_row = GPOINTER_TO_INT(list_sel->data);
			user_id = (gint)
				wbr_get_datfile_item(WBR_MAN_GROUPID, sel_row);
			user_id |= group_id;
			wbr_set_group_id(sel_row, user_id);
			list_sel = g_list_next(list_sel);
			group_num++;
		}

		wbr_put_group_info(group_num,
			group_id, new_gname, group_index);
		Wbrg_chg_flag = TRUE;
		gtk_widget_destroy(main_window);
	} else {
		wmc_create_emsg_dialog(main_window,
			WBR_STR_ERROR, WBR_STR_ERR_GNAME);
	}
}

/*===============
 *   ̾ : wbrg_cb_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼Խɥ
)
{
	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : wbrg_create_gedit_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrg_create_gedit_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*list_titles[] = {	// ꥹȹ̾
						WBR_STR_LIST_NAME, WBR_STR_LIST_BIRTH
					};
	GtkWidget		*gedit_window;		// ϥɥ
	GtkWidget		*gedit_vbox;		//
	GtkWidget		*gedit_hbox;		//
	gchar			*title;				// ȥʸ
	GtkWidget		*title_label;		// ٥
	GtkWidget		*list_scrl;			// 륦ɥ
	GtkWidget		*group_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_ok;			// Ͽܥ
	GtkWidget		*cmd_cancel;		// ߥܥ
	GtkAccelGroup	*accel_group;		// 졼

	// ɥ
	title = g_strconcat(WBR_TT_GRPEDIT, NULL);
	gedit_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(gedit_window), title);
	gtk_window_set_position(GTK_WINDOW(gedit_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(gedit_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(gedit_window), "destroy",
					GTK_SIGNAL_FUNC(wbrg_cb_destroy), NULL);
	g_free(title);

	// ٥
	gedit_vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_border_width(GTK_CONTAINER(gedit_vbox), 5);
	gtk_container_add(GTK_CONTAINER(gedit_window), gedit_vbox);
	gtk_widget_show(gedit_vbox);

	// 롼̾
	gedit_hbox = gtk_hbox_new(FALSE, 10);
	gtk_box_pack_start(GTK_BOX(gedit_vbox), gedit_hbox, FALSE, TRUE, 0);

	title = g_strconcat(WBR_STR_GROUP, NULL);
	title_label = gtk_label_new(title);
	gtk_misc_set_alignment(GTK_MISC(title_label), 0, 0);
	gtk_box_pack_start(GTK_BOX(gedit_hbox),
				title_label, FALSE, TRUE, 0);
	g_free(title);

	Wbrg_gname = gtk_entry_new_with_max_length(20);
	gtk_box_pack_start(GTK_BOX(gedit_hbox), Wbrg_gname, FALSE, TRUE, 0);

	// ꥹȥܥå
	list_scrl = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(list_scrl), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(list_scrl),
									GTK_POLICY_AUTOMATIC,
									GTK_POLICY_AUTOMATIC);
	gtk_widget_set_usize(GTK_WIDGET(list_scrl), 300, 200);
	gtk_box_pack_start(GTK_BOX(gedit_vbox), list_scrl, FALSE, TRUE, 20);

	Wbrg_list = gtk_clist_new_with_titles(2, list_titles);
	gtk_clist_set_column_width(GTK_CLIST(Wbrg_list), 0, 150);
	gtk_clist_set_selection_mode(GTK_CLIST(Wbrg_list),
								GTK_SELECTION_EXTENDED);

	wbrg_set_list_data(Wbrg_gname, Wbrg_list);
	gtk_container_add(GTK_CONTAINER(list_scrl), Wbrg_list);

	// ѥ졼
	group_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(gedit_vbox), group_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(gedit_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_cancel_clicked),
						GTK_OBJECT(gedit_window));

	cmd_ok = gtk_button_new_with_label(WBR_STR_BTN_ENTRY);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_ok, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_ok), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_ok_clicked),
						GTK_OBJECT(gedit_window));
	GTK_WIDGET_SET_FLAGS(cmd_ok, GTK_CAN_DEFAULT);

	// 졼
	accel_group = gtk_accel_group_new();
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_E, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_ok, "clicked", accel_group,
							GDK_Return, 0, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_C, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_Escape, 0, GTK_ACCEL_VISIBLE);
	gtk_window_add_accel_group(GTK_WINDOW(gedit_window), accel_group);

	gtk_widget_grab_default(cmd_ok);
	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(gedit_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(gedit_window),
									GTK_WINDOW(parent));
	}

	return gedit_window;
}

/*===============
 *   ̾ : wbrg_set_list_data()
 *     ǽ : ̾ꥹȤΥå
 *    : ʤ
 */
static void			wbrg_set_list_data(
GtkWidget			*group_text,		// (I) 롼̾ƥ
GtkWidget			*group_list			// (I) ̾ꥹ
)
{
	gint			loop_cnt;			// 롼ץ
	gchar			**list_item;		// ꥹȹ
	gint			man_cnt;			// ;
	gchar			*user_name;			// ̾
	gint			birthday;			// 
	gint			user_id;			// 롼ףɣ
	gchar			temp_date[20];		// ʸ
	gchar			date_fmt[20];		// եեޥå
	gint			user_num;			// Ͽ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾

	// ƥ
	wbr_get_group_info(&user_num, &group_id, &group_name, -1);
	gtk_entry_set_text(GTK_ENTRY(group_text), group_name);

	// ꥹ
	gtk_clist_clear(GTK_CLIST(group_list));
	list_item = g_malloc(2 * sizeof(gchar *));
	if ((gboolean)wbr_get_param(WBR_PRM_ID_BIRTHYEAR) == TRUE) {
		strcpy(date_fmt, "%Y/%m/%d");
	}
	else {
		strcpy(date_fmt, "%m/%d");
	}

	man_cnt = wbr_get_datfile_cnt();
	for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
		user_name = wbr_get_datfile_item(WBR_MAN_NAME, loop_cnt);
		birthday = (gint)
			wbr_get_datfile_item(WBR_MAN_BIRTHDAY, loop_cnt);
		user_id = (gint)
			wbr_get_datfile_item(WBR_MAN_GROUPID, loop_cnt);

		wmc_get_date_string(temp_date, date_fmt, birthday);
		list_item[0] = g_strconcat(user_name, NULL);
		list_item[1] = g_strconcat(temp_date, NULL);
		gtk_clist_append(GTK_CLIST(group_list), list_item);
		g_free(list_item[0]);
		g_free(list_item[1]);

		if ((group_id & user_id) != 0) {
			gtk_clist_select_row(GTK_CLIST(group_list), loop_cnt, 1);
		}
	}
	g_free(list_item);
}
