/*
 * Хꥺɽե
 *	롼װ
 *
 * Copyright (C) 1999-2002 Whitire Company (tonton@whitire.com)
 * $Id: br_grmain.c,v 1.1 2002/11/15 09:59:22 tonton Exp $
 */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string.h>

#include "wmc_ptype.h"

#include "brthm.h"
#include "br_sdef.h"

static GtkWidget	*Wbrg_list;			// ꥹ
static GtkWidget	*Wbrg_bnew;			// ܥ
static GtkWidget	*Wbrg_bedit;		// Խܥ
static GtkWidget	*Wbrg_bdelete;		// ܥ
static GtkWidget	*Wbrg_brenew;		// ܥ
static GtkWidget	*Wbrg_bselect;		// ܥ
static gboolean		Wbrg_selcan;		// 
static gboolean		Wbrg_chg_flag;		// ѹե饰
static gint			Wbrg_gno[WBR_MAX_GROUP];
										// 롼ֹʥꥹȤб
static gint			Wbrg_lsel;			// ꥹ

static void			wbrg_cb_destroy(void);
static void			wbrg_cb_list_selected(GtkWidget *,
						gint, gint, GdkEventButton *, gpointer);
static void			wbrg_cb_new_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_edit_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_delete_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_renew_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_select_clicked(GtkWidget *, gpointer);
static void			wbrg_cb_cancel_clicked(GtkWidget *, gpointer);
static GtkWidget	*wbrg_create_group_window(GtkWidget *);
static gint			wbrg_set_window_data(void);

/*===============
 *   ̾ : wbr_group_main()
 *     ǽ : 롼װɥκ
 *    : TRUE= , FALSE= 
 */
gboolean			wbr_group_main(
gboolean			*item_change,		// (O) ѹ
										//	TRUE= ѹ
GtkWidget			*parent				// (I) ƥɥ
)
{
	GtkWidget		*group_window;		// 롼װɥ

	Wbrg_selcan = FALSE;
	Wbrg_chg_flag = FALSE;
	group_window = wbrg_create_group_window(parent);
	gtk_widget_show_all(group_window);
	gtk_main();
	*item_change = Wbrg_chg_flag;

	return Wbrg_selcan;
}

/*===============
 *   ̾ : wbrg_cb_destroy()
 *     ǽ : ɥ˲Хå
 *    : ʤ
 */
static void			wbrg_cb_destroy(void)
{
	gtk_main_quit();
}

/*===============
 *   ̾ : wbrg_cb_list_selected()
 *     ǽ : ꥹ򥳡Хå
 *    : ʤ
 */
static void			wbrg_cb_list_selected(
GtkWidget			*list,				// (I) ꥹ
gint				row,				// (I) 
gint				column,				// (I) 
GdkEventButton		*event,				// (I) ꥹ
gpointer			user_data			// (I) ̤
)
{
	Wbrg_lsel = row;
}

/*===============
 *   ̾ : wbrg_cb_new_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_new_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼װɥ
)
{
	gboolean		ret_code;			// 
	gint			group_id;			// 롼ֹ
	gint			list_num;			// ꥹȿ

	group_id = wbr_get_new_group_id();
	ret_code = wbr_gedit_main(main_window, WBR_GRP_NEW);
	if (ret_code == TRUE) {
		list_num = wbrg_set_window_data();
		gtk_clist_select_row(GTK_CLIST(Wbrg_list), group_id, 1);
		Wbrg_chg_flag = TRUE;
	}
}

/*===============
 *   ̾ : wbrg_cb_edit_clicked()
 *     ǽ : Խܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_edit_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼װɥ
)
{
	gboolean		ret_code;			// 
	gint			sel_pos;			// ꥹ

	wbr_put_group_index(Wbrg_gno[Wbrg_lsel]);
	ret_code = wbr_gedit_main(main_window, WBR_GRP_EDIT);
	if (ret_code == TRUE) {
		sel_pos = Wbrg_lsel;
		wbrg_set_window_data();
		gtk_clist_select_row(GTK_CLIST(Wbrg_list), sel_pos, 1);
		Wbrg_chg_flag = TRUE;
	}
}

/*===============
 *   ̾ : wbrg_cb_delete_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_delete_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼װɥ
)
{
	gchar			*conf_msg;			// ǧå
	gint			group_num;			// Ͽ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾
	gboolean		yes_no;				// γǧ
	gint			loop_cnt;			// 롼ץ
	gint			man_cnt;			// ;
	gint			user_id;			// 롼ףɣ

	wbr_get_group_info(&group_num,
		&group_id, &group_name, Wbrg_gno[Wbrg_lsel]);
	conf_msg = g_strconcat("[ ", group_name, " ]",
							WBR_STR_QST_GDEL, NULL);
	yes_no = wmc_create_qmsg_dialog(main_window,
					WBR_STR_QUESTION, conf_msg);
	if (yes_no == TRUE) {
		wbr_put_group_info(0, 0, "", Wbrg_gno[Wbrg_lsel]);
		man_cnt = wbr_get_datfile_cnt();
		for (loop_cnt = 0; loop_cnt < man_cnt; loop_cnt++) {
			user_id = (gint)
				wbr_get_datfile_item(WBR_MAN_GROUPID, loop_cnt);
			if ((group_id & user_id) != 0) {
				user_id ^= group_id;
				wbr_set_group_id(loop_cnt, user_id);
			}
		}

		Wbrg_chg_flag = TRUE;
		wbrg_set_window_data();
	}
}

/*===============
 *   ̾ : wbrg_cb_renew_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_renew_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			user_data			// (I) ̤
)
{
	gboolean		s_change;			// ѹ̵ͭ
	gint			group_cnt;			// 롼ץ
	gint			group_num;			// Ͽ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾
	gint			new_gnum;			// Ͽ
	gint			user_cnt;			// 롼ץ
	gint			man_cnt;			// ;
	gint			user_id;			// 롼ףɣ
	gint			sel_pos;			// ꥹ

	s_change = FALSE;
	man_cnt = wbr_get_datfile_cnt();
	for (group_cnt = 0; group_cnt < WBR_MAX_GROUP; group_cnt++) {
		wbr_get_group_info(&group_num,
			&group_id, &group_name, group_cnt);

		if (group_id != 0) {
			new_gnum = 0;
			for (user_cnt = 0; user_cnt < man_cnt; user_cnt++) {
				user_id = (gint)
					wbr_get_datfile_item(WBR_MAN_GROUPID, user_cnt);
				if ((group_id & user_id) != 0) {
					new_gnum++;
				}
			}
			if (group_num != new_gnum) {
				wbr_put_group_info(new_gnum,
					group_id, group_name, group_cnt);
				s_change = TRUE;
			}
		}
	}

	if (s_change == TRUE) {
		sel_pos = Wbrg_lsel;
		wbrg_set_window_data();
		gtk_clist_select_row(GTK_CLIST(Wbrg_list), sel_pos, 1);
		Wbrg_chg_flag = TRUE;
	}
}

/*===============
 *   ̾ : wbrg_cb_select_clicked()
 *     ǽ : ܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_select_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼װɥ
)
{
	Wbrg_selcan = TRUE;
	wbr_put_group_index(Wbrg_gno[Wbrg_lsel]);
	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : wbrg_cb_cancel_clicked()
 *     ǽ : ߥܥ󲡲Хå
 *    : ʤ
 */
static void			wbrg_cb_cancel_clicked(
GtkWidget			*button,			// (I) ܥ
gpointer			main_window			// (I) 롼װɥ
)
{
	gtk_widget_destroy(main_window);
}

/*===============
 *   ̾ : wbrg_create_group_window()
 *     ǽ : ɥ
 *    : ɥ
 */
static GtkWidget	*wbrg_create_group_window(
GtkWidget			*parent				// (I) ƥɥ
)
{
	gchar			*list_titles[] = {	// ꥹȹ̾
						WBR_STR_LIST_GNAME, WBR_STR_LIST_GNUM
					};
	GtkWidget		*group_window;		// 롼װɥ
	GtkWidget		*group_vbox;		//
	GtkWidget		*group_hbox;		//
	GtkWidget		*list_scrl;			// 륦ɥ
	GtkWidget		*cmd_vbox;			//
	GtkWidget		*group_sep;			// ѥ졼
	GtkWidget		*cmd_hbox;			// ܥܥå
	GtkWidget		*cmd_cancel;		// ߥܥ
	gchar			*title;				// ȥʸ
	GtkAccelGroup	*accel_group;		// 졼

	// ɥ
	title = g_strconcat(WBR_TT_GRPMAIN, NULL);
	group_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(group_window), title);
	gtk_window_set_position(GTK_WINDOW(group_window),
							GTK_WIN_POS_MOUSE);
	gtk_window_set_policy(GTK_WINDOW(group_window), TRUE, TRUE, FALSE);
	gtk_signal_connect(GTK_OBJECT(group_window), "destroy",
					GTK_SIGNAL_FUNC(wbrg_cb_destroy), NULL);
	g_free(title);

	// ꥹȥܥå
	group_vbox = gtk_vbox_new(FALSE, 10);
	gtk_container_border_width(GTK_CONTAINER(group_vbox), 5);
	gtk_container_add(GTK_CONTAINER(group_window), group_vbox);
	gtk_widget_show(group_vbox);

	group_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(group_vbox), group_hbox, TRUE, TRUE, 5);

	list_scrl = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(list_scrl), 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(list_scrl),
									GTK_POLICY_AUTOMATIC,
									GTK_POLICY_AUTOMATIC);
	gtk_widget_set_usize(GTK_WIDGET(list_scrl), 300, 200);
	gtk_box_pack_start(GTK_BOX(group_hbox), list_scrl, FALSE, TRUE, 20);

	Wbrg_list = gtk_clist_new_with_titles(2, list_titles);
	gtk_clist_set_column_width(GTK_CLIST(Wbrg_list), 0, 150);
	gtk_clist_set_selection_mode(GTK_CLIST(Wbrg_list),
								GTK_SELECTION_BROWSE);
	gtk_container_add(GTK_CONTAINER(list_scrl), Wbrg_list);
	gtk_signal_connect(GTK_OBJECT(Wbrg_list), "select_row",
					GTK_SIGNAL_FUNC(wbrg_cb_list_selected), NULL);

	// Խܥ
	cmd_vbox = gtk_vbutton_box_new();
	gtk_box_pack_start(GTK_BOX(group_hbox), cmd_vbox, FALSE, FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(cmd_vbox), 0);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(cmd_vbox),
								GTK_BUTTONBOX_START);
	gtk_button_box_set_spacing(GTK_BUTTON_BOX(cmd_vbox), 1);

	Wbrg_bnew = gtk_button_new_with_label(WBR_STR_BTN_NEW_);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), Wbrg_bnew);
	gtk_signal_connect(GTK_OBJECT(Wbrg_bnew), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_new_clicked),
						GTK_OBJECT(group_window));

	Wbrg_bedit = gtk_button_new_with_label(WBR_STR_BTN_EDIT_);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), Wbrg_bedit);
	gtk_signal_connect(GTK_OBJECT(Wbrg_bedit), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_edit_clicked),
						GTK_OBJECT(group_window));

	Wbrg_bdelete = gtk_button_new_with_label(WBR_STR_BTN_DELETE);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), Wbrg_bdelete);
	gtk_signal_connect(GTK_OBJECT(Wbrg_bdelete), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_delete_clicked),
						GTK_OBJECT(group_window));

	group_sep = gtk_hseparator_new();
	gtk_container_add(GTK_CONTAINER(cmd_vbox), group_sep);

	Wbrg_brenew = gtk_button_new_with_label(WBR_STR_BTN_RENEW);
	gtk_container_add(GTK_CONTAINER(cmd_vbox), Wbrg_brenew);
	gtk_signal_connect(GTK_OBJECT(Wbrg_brenew), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_renew_clicked),
						NULL);

	// ѥ졼
	group_sep = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(group_vbox), group_sep, FALSE, TRUE, 5);

	// ܥ
	cmd_hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_end(GTK_BOX(group_vbox), cmd_hbox, FALSE, TRUE, 0);

	cmd_cancel = gtk_button_new_with_label(WBR_STR_BTN_CANCEL);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), cmd_cancel, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(cmd_cancel), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_cancel_clicked),
						GTK_OBJECT(group_window));

	Wbrg_bselect = gtk_button_new_with_label(WBR_STR_BTN_SELECT);
	gtk_box_pack_end(GTK_BOX(cmd_hbox), Wbrg_bselect, FALSE, TRUE, 5);
	gtk_signal_connect(GTK_OBJECT(Wbrg_bselect), "clicked",
						GTK_SIGNAL_FUNC(wbrg_cb_select_clicked),
						GTK_OBJECT(group_window));
	GTK_WIDGET_SET_FLAGS(Wbrg_bselect, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(Wbrg_bselect);

	// 졼
	accel_group = gtk_accel_group_new();
	gtk_widget_add_accelerator(Wbrg_bnew, "clicked", accel_group,
							GDK_N, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(Wbrg_bedit, "clicked", accel_group,
							GDK_E, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(Wbrg_bdelete, "clicked", accel_group,
							GDK_D, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(Wbrg_brenew, "clicked", accel_group,
							GDK_R, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(Wbrg_bselect, "clicked", accel_group,
							GDK_S, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(Wbrg_bselect, "clicked", accel_group,
							GDK_Return, 0, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_C, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
	gtk_widget_add_accelerator(cmd_cancel, "clicked", accel_group,
							GDK_Escape, 0, GTK_ACCEL_VISIBLE);
	gtk_window_add_accel_group(GTK_WINDOW(group_window), accel_group);

	wbrg_set_window_data();
	if (parent != NULL) {
		gtk_window_set_modal(GTK_WINDOW(group_window), TRUE);
		gtk_window_set_transient_for(GTK_WINDOW(group_window),
									GTK_WINDOW(parent));
	}

	return group_window;
}

/*===============
 *   ̾ : wbrg_set_window_data()
 *     ǽ : ɽ
 *    : ꥹϿ
 */
static gint			wbrg_set_window_data(void)
{
	gchar			**list_item;		// ꥹȹ
	gint			user_num;			// Ͽ
	gchar			temp_num[10];		// Ͽɽѡ
	gint			group_id;			// 롼ףɣ
	gchar			*group_name;		// 롼̾
	gint			loop_cnt;			// 롼ץ
	gint			disp_num;			// ꥹɽ
	gboolean		btn_status;			// ܥ

	disp_num = 0;
	memset(Wbrg_gno, 0, sizeof(gint) * WBR_MAX_GROUP);
	gtk_clist_clear(GTK_CLIST(Wbrg_list));
	list_item = g_malloc(2 * sizeof(gchar *));

	for (loop_cnt = 0; loop_cnt < WBR_MAX_GROUP; loop_cnt++) {
		wbr_get_group_info(&user_num, &group_id, &group_name, loop_cnt);
		if (group_id != 0) {
			sprintf(temp_num, "%d", user_num);
			list_item[0] = g_strconcat(group_name, NULL);
			list_item[1] = g_strconcat(temp_num, NULL);
			gtk_clist_append(GTK_CLIST(Wbrg_list), list_item);
			Wbrg_gno[disp_num] = loop_cnt;
			g_free(list_item[0]);
			g_free(list_item[1]);
			disp_num++;
		}
	}
	g_free(list_item);

	if (disp_num == 0) {
		btn_status = FALSE;
		Wbrg_lsel = -1;
	} else {
		btn_status = TRUE;
		Wbrg_lsel = 0;
	}
	gtk_widget_set_sensitive(Wbrg_bedit, btn_status);
	gtk_widget_set_sensitive(Wbrg_bdelete, btn_status);
	gtk_widget_set_sensitive(Wbrg_brenew, btn_status);
	gtk_widget_set_sensitive(Wbrg_bselect, btn_status);

	if (disp_num >= WBR_MAX_GROUP) {
		btn_status = FALSE;
	} else {
		btn_status = TRUE;
	}
	gtk_widget_set_sensitive(Wbrg_bnew, btn_status);

	return disp_num;
}
