/*
 * ̴ؿ
 *	ɥؿ
 *
 * Copyright (C) 1999,2000 Whitire Company (tonton@whitire.com)
 * $Id: wmc_wstat.c,v 1.1 2000/08/25 11:50:32 tonton Exp $
 */

#include <X11/Xlib.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>

#include "wmc_sdef.h"
#include "wmc_ptype.h"

/*===============
 *   ̾ : wmc_window_set_focus()
 *     ǽ : ե
 *    : FALSE= Ƶʤ
 */
gint				wmc_window_set_focus(
GtkWidget			*focus_win			// (I) ꥦɥ
)
{
	XWindowAttributes	win_attr;		// ɥ°

	XGetWindowAttributes(GDK_DISPLAY(),
		GDK_WINDOW_XWINDOW(focus_win->window), &win_attr);

	/*
	 *	ɥ󲽤λ XSetInputFocus() ƤӽФ
	 *	core dump Τǡöᤷƣø˺ٽ롣
	 */
	if (win_attr.map_state == IsUnmapped) {
		gdk_window_show(focus_win->window);
		gtk_timeout_add(100,
			(GtkFunction)wmc_window_set_focus, focus_win);
	}
	else {
		gdk_window_raise(focus_win->window);
		XSetInputFocus(GDK_DISPLAY(),
			GDK_WINDOW_XWINDOW(focus_win->window),
			RevertToNone, GDK_CURRENT_TIME);
	}

	return FALSE;
}

/*===============
 *   ̾ : wmc_window_decorations()
 *     ǽ : ɥȤȰưꥵ
 *    : ʤ
 */
void				wmc_window_decorations(
GtkWidget			*dec_win,			// (I) ꥦɥ
gint				decorations,		// (I) Ȥ
gint				pos_x,				// (I) ưɸ
gint				pos_y,				// (I) ưɸ
gint				width,				// (I) ɥ
gint				height				// (I) ɥ⤵
)
{
	gtk_widget_hide(dec_win);
	gdk_window_set_decorations(dec_win->window, decorations);
	gtk_window_set_default_size(GTK_WINDOW(dec_win), width, height);
	gtk_widget_show(dec_win);
	gtk_window_reposition(GTK_WINDOW(dec_win), pos_x, pos_y);
}
